'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Accordion = function (_PureComponent) {
  (0, _inherits3.default)(Accordion, _PureComponent);

  function Accordion(props) {
    (0, _classCallCheck3.default)(this, Accordion);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Accordion.__proto__ || Object.getPrototypeOf(Accordion)).call(this, props));

    _this.renderItem = _this.renderItem.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Accordion, [{
    key: 'handleClick',
    value: function handleClick(index) {
      var newIndex = index === this.props.activeIndex ? null : index;
      this.props.onChange(newIndex);
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, index) {
      var isActive = index === this.props.activeIndex;
      var className = (0, _classnames2.default)('c-accordion-item', { 'is-active': isActive });
      var iconClassname = (0, _classnames2.default)({ 'icon-arrow_down': !isActive, 'icon-arrow_up': isActive });

      var content = void 0;
      if (isActive) content = _react2.default.createElement(
        'div',
        { className: 'c-accordion-item-content' },
        item.content
      );

      return _react2.default.createElement(
        'li',
        { key: item.title, className: className },
        _react2.default.createElement(
          'div',
          { className: 'c-accordion-item-title', onClick: this.handleClick.bind(this, index) },
          _react2.default.createElement('i', { className: iconClassname }),
          ' ',
          item.title
        ),
        content
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-accordion', this.props.className);
      var cleanProps = (0, _omit2.default)(this.props, 'activeIndex', 'items', 'onChange');

      return _react2.default.createElement(
        'ul',
        (0, _extends3.default)({}, cleanProps, { className: className }),
        this.props.items.map(this.renderItem)
      );
    }
  }]);
  return Accordion;
}(_react.PureComponent);

Accordion.defaultProps = {
  activeIndex: 0
};

exports.default = Accordion;