'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var Autocomplete,
      ContextList,
      Input,
      InputProxyComponent,
      React,
      classNames,
      defaultGetValue,
      eventproxy,
      keymanager,
      omit,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  omit = require('lodash/omit');

  classNames = require('classnames');

  keymanager = require('nebenan-helpers/lib/keymanager').default;

  eventproxy = require('nebenan-helpers/lib/eventproxy').default;

  InputProxyComponent = require('nebenan-base-class/lib/input_proxy_component');

  Input = require('../input');

  ContextList = require('../context_list');

  defaultGetValue = function defaultGetValue(key, options) {
    return options[key];
  };

  Autocomplete = function (_InputProxyComponent) {
    (0, _inherits3.default)(Autocomplete, _InputProxyComponent);

    function Autocomplete() {
      (0, _classCallCheck3.default)(this, Autocomplete);

      var _this = (0, _possibleConstructorReturn3.default)(this, (Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).apply(this, arguments));

      _this.focus = _this.focus.bind(_this);
      _this.blur = _this.blur.bind(_this);
      _this.show = _this.show.bind(_this);
      _this.hide = _this.hide.bind(_this);
      _this.handleGlobalClick = _this.handleGlobalClick.bind(_this);
      _this.handleSelect = _this.handleSelect.bind(_this);
      _this.handleUpdate = _this.handleUpdate.bind(_this);
      return _this;
    }

    (0, _createClass3.default)(Autocomplete, [{
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.hide();
        return (0, _get3.default)(Autocomplete.prototype.__proto__ || Object.getPrototypeOf(Autocomplete.prototype), 'componentWillUnmount', this).call(this);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var ref;
        if (((ref = nextProps.options) != null ? ref.length : void 0) && nextProps.options !== this.props.options) {
          return this.show();
        } else {
          return this.hide();
        }
      }
    }, {
      key: 'focus',
      value: function focus() {
        boundMethodCheck(this, Autocomplete);
        return this.getInput().focus();
      }
    }, {
      key: 'blur',
      value: function blur() {
        boundMethodCheck(this, Autocomplete);
        return this.getInput().blur();
      }
    }, {
      key: 'show',
      value: function show() {
        boundMethodCheck(this, Autocomplete);
        if (this.isActive) {
          return;
        }
        this.refs.list.activate();
        this.stopListeningToKeys = keymanager('esc', this.hide);
        this.stopListeningToClicks = eventproxy('click', this.handleGlobalClick);
        return this.isActive = true;
      }
    }, {
      key: 'hide',
      value: function hide() {
        boundMethodCheck(this, Autocomplete);
        if (!this.isActive) {
          return;
        }
        this.refs.list.deactivate();
        this.stopListeningToKeys();
        this.stopListeningToClicks();
        return this.isActive = false;
      }
    }, {
      key: 'handleGlobalClick',
      value: function handleGlobalClick(event) {
        boundMethodCheck(this, Autocomplete);
        if (!this.isComponentMounted) {
          return;
        }
        if (!this.refs.container.contains(event.target)) {
          return this.hide();
        }
      }
    }, {
      key: 'handleSelect',
      value: function handleSelect(key) {
        var _this2 = this;

        var complete, getValue, value;
        boundMethodCheck(this, Autocomplete);
        getValue = this.props.getValue || defaultGetValue;
        value = getValue(key, this.props.options);
        complete = function complete() {
          var base;
          _this2.isSelected = false;
          _this2.hide();
          _this2.refs.input.validate();
          return typeof (base = _this2.props).onSelect === "function" ? base.onSelect(value, key) : void 0;
        };
        this.isSelected = true;
        return this.refs.input.setValue(value, complete);
      }
    }, {
      key: 'handleUpdate',
      value: function handleUpdate(value) {
        var base, base1, base2;
        boundMethodCheck(this, Autocomplete);
        if (this.isSelected) {
          return typeof (base = this.props).onUpdate === "function" ? base.onUpdate(value, 'select') : void 0;
        } else {
          if (typeof (base1 = this.props).onUpdate === "function") {
            base1.onUpdate(value, 'change');
          }
          return typeof (base2 = this.props).onInput === "function" ? base2.onInput(value) : void 0;
        }
      }
    }, {
      key: 'renderList',
      value: function renderList() {
        var getOption, options;
        var _props = this.props;
        options = _props.options;
        getOption = _props.getOption;

        return React.createElement(ContextList, { ref: 'list', className: 'ui-card ui-options', options: options, getOption: getOption, onSelect: this.handleSelect });
      }
    }, {
      key: 'render',
      value: function render() {
        var className, cleanProps;
        className = classNames('c-autocomplete', this.props.className);
        cleanProps = omit(this.props, 'children', 'options', 'getOption', 'onInput', 'onSelect', 'getValue', 'className');
        return React.createElement(
          'article',
          { ref: 'container', className: className },
          React.createElement(
            Input,
            (0, _extends3.default)({}, cleanProps, { ref: 'input', autoComplete: 'off', onUpdate: this.handleUpdate }),
            this.renderList(),
            this.props.children
          )
        );
      }
    }]);
    return Autocomplete;
  }(InputProxyComponent);

  module.exports = Autocomplete;
}).call(undefined);