'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _interactive_component = require('nebenan-base-class/lib/interactive_component');

var _interactive_component2 = _interopRequireDefault(_interactive_component);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _clamp = require('lodash/clamp');

var _clamp2 = _interopRequireDefault(_clamp);

var _eventproxy = require('nebenan-helpers/lib/eventproxy');

var _eventproxy2 = _interopRequireDefault(_eventproxy);

var _dom = require('nebenan-helpers/lib/utils/dom');

var _draggable = require('../draggable');

var _draggable2 = _interopRequireDefault(_draggable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BOUNDARIES_EXCESS = 40;

var Carousel = function (_InteractiveComponent) {
  (0, _inherits3.default)(Carousel, _InteractiveComponent);

  function Carousel(props) {
    (0, _classCallCheck3.default)(this, Carousel);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Carousel.__proto__ || Object.getPrototypeOf(Carousel)).call(this, props));

    _this.state = { position: 0, isAnimated: false };

    _this.bindToComponent('handleDragStart', 'handleDrag', 'handleDragStop', 'handleResize');
    return _this;
  }

  (0, _createClass3.default)(Carousel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _get3.default)(Carousel.prototype.__proto__ || Object.getPrototypeOf(Carousel.prototype), 'componentDidMount', this).call(this);
      this.stopListeningToResize = (0, _eventproxy2.default)('resize', this.handleResize);
      this.calculateMeasurements();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.stopListeningToResize();
      (0, _get3.default)(Carousel.prototype.__proto__ || Object.getPrototypeOf(Carousel.prototype), 'componentWillUnmount', this).call(this);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.children !== this.props.children) {
        process.nextTick(this.handleResize);
      }
    }
  }, {
    key: 'calculateMeasurements',
    value: function calculateMeasurements() {
      var containerWidth = (0, _dom.size)(this.els.draggable.getNode()).width;
      var wrapperWidth = (0, _dom.size)(this.els.wrapper).width;

      this.minPosition = Math.min(wrapperWidth - containerWidth, 0);
    }
  }, {
    key: 'alignPosition',
    value: function alignPosition() {
      var position = (0, _clamp2.default)(this.state.position, this.minPosition, 0);
      this.setPosition(position, true);
    }
  }, {
    key: 'setPosition',
    value: function setPosition(position) {
      var isAnimated = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      this.setState({ position: position, isAnimated: isAnimated });
    }
  }, {
    key: 'handleResize',
    value: function handleResize() {
      if (!this.isComponentMounted) return;
      this.calculateMeasurements();
      this.alignPosition();
    }
  }, {
    key: 'handleDragStart',
    value: function handleDragStart(event) {
      this.startPosition = this.state.position;
      this.startX = (0, _dom.eventCoordinates)(event, 'pageX').pageX;
    }
  }, {
    key: 'handleDrag',
    value: function handleDrag(event) {
      var diff = (0, _dom.eventCoordinates)(event, 'pageX').pageX - this.startX;
      var minPosition = this.minPosition - BOUNDARIES_EXCESS;
      var position = (0, _clamp2.default)(this.startPosition + diff, minPosition, BOUNDARIES_EXCESS);

      this.setPosition(position);
    }
  }, {
    key: 'handleDragStop',
    value: function handleDragStop() {
      this.alignPosition();
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item) {
      return _react2.default.createElement(
        'li',
        { className: 'c-carousel-item' },
        item
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-carousel', this.props.className, { 'is-animated': this.state.isAnimated });
      var _props = this.props,
          children = _props.children,
          cleanProps = (0, _objectWithoutProperties3.default)(_props, ['children']);

      var items = _react.Children.map(children, this.renderItem);

      var draggableStyle = (0, _dom.getPrefixed)({ transform: 'translateX(' + this.state.position + 'px)' });

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className }),
        _react2.default.createElement(
          'div',
          { className: 'c-carousel-wrapper', ref: this.setEl('wrapper') },
          _react2.default.createElement(
            _draggable2.default,
            {
              ref: this.setEl('draggable'),
              style: draggableStyle,
              className: 'c-carousel-draggable',
              onDragStart: this.handleDragStart,
              onDrag: this.handleDrag,
              onDragStop: this.handleDragStop
            },
            _react2.default.createElement(
              'ul',
              { className: 'c-carousel-list' },
              items
            )
          )
        )
      );
    }
  }]);
  return Carousel;
}(_interactive_component2.default);

Carousel.propTypes = {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string
};

exports.default = Carousel;