'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _map_component = require('nebenan-base-class/lib/map_component');

var _map_component2 = _interopRequireDefault(_map_component);

var _data = require('nebenan-helpers/lib/utils/data');

var _utils = require('./utils');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Circle = function (_MapComponent) {
  (0, _inherits3.default)(Circle, _MapComponent);

  function Circle() {
    (0, _classCallCheck3.default)(this, Circle);
    return (0, _possibleConstructorReturn3.default)(this, (Circle.__proto__ || Object.getPrototypeOf(Circle)).apply(this, arguments));
  }

  (0, _createClass3.default)(Circle, [{
    key: 'update',
    value: function update(nextProps, nextContext) {
      this.destroy();
      this.create(nextProps, nextContext);
    }
  }, {
    key: 'create',
    value: function create(props, context) {
      var _require = require('leaflet'),
          createCircle = _require.circle;

      var center = props.center;

      var options = (0, _utils.getOptions)(props);
      var circle = createCircle((0, _data.reverse)(center), options);

      context.map.addLayer(circle);
      this.circle = circle;
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.context.map.removeLayer(this.circle);
      this.circle = null;
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);
  return Circle;
}(_map_component2.default); /* eslint react/no-unused-prop-types: "off" */


Circle.defaultProps = {
  type: _constants.CIRCLE_DEFAULT
};

Circle.propTypes = {
  type: _propTypes2.default.oneOf([_constants.CIRCLE_ACTIVE, _constants.CIRCLE_DEFAULT]).isRequired,

  center: _propTypes2.default.arrayOf(_propTypes2.default.number).isRequired,
  radius: _propTypes2.default.number.isRequired
};

exports.default = Circle;