'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var ContextList,
      DOWN,
      ENTER,
      LEFT,
      RIGHT,
      React,
      SPACE,
      TAB,
      UP,
      classNames,
      defaultGetOption,
      keymanager,
      omit,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  omit = require('lodash/omit');

  classNames = require('classnames');

  keymanager = require('nebenan-helpers/lib/keymanager').default;

  var _require = require('nebenan-helpers/lib/constants/keys');

  DOWN = _require.DOWN;
  RIGHT = _require.RIGHT;
  TAB = _require.TAB;
  UP = _require.UP;
  LEFT = _require.LEFT;
  ENTER = _require.ENTER;
  SPACE = _require.SPACE;


  defaultGetOption = function defaultGetOption(key, options) {
    return options[key];
  };

  ContextList = function () {
    var ContextList = function (_React$PureComponent) {
      (0, _inherits3.default)(ContextList, _React$PureComponent);

      function ContextList(props) {
        (0, _classCallCheck3.default)(this, ContextList);

        var _this = (0, _possibleConstructorReturn3.default)(this, (ContextList.__proto__ || Object.getPrototypeOf(ContextList)).call(this, props));

        _this.handleKey = _this.handleKey.bind(_this);
        _this.handleMouseLeave = _this.handleMouseLeave.bind(_this);
        _this.renderOption = _this.renderOption.bind(_this);
        _this.state = {
          keys: Object.keys(props.options),
          isActive: false,
          selected: null
        };
        return _this;
      }

      (0, _createClass3.default)(ContextList, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          return this.deactivate();
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var nextState;
          if (this.props.options !== nextProps.options) {
            nextState = {
              keys: Object.keys(nextProps.options),
              selected: null
            };
            return this.setState(nextState);
          }
        }
      }, {
        key: 'isActive',
        value: function isActive() {
          return this.state.isActive;
        }
      }, {
        key: 'activate',
        value: function activate() {
          if (this.state.isActive) {
            return;
          }
          this.stopListening = keymanager('down right tab up left enter space', this.handleKey);
          return this.setState({
            isActive: true
          });
        }
      }, {
        key: 'deactivate',
        value: function deactivate() {
          if (!this.state.isActive) {
            return;
          }
          if (typeof this.stopListening === "function") {
            this.stopListening();
          }
          return this.setState({
            isActive: false,
            selected: null
          });
        }
      }, {
        key: 'selectNext',
        value: function selectNext(done) {
          var updater;
          updater = function updater(state) {
            var index, newSelected;
            if (state.selected) {
              index = Math.max(0, state.keys.indexOf(state.selected));
            }
            newSelected = state.keys[index + 1] || state.keys[0];
            return {
              selected: newSelected
            };
          };
          return this.setState(updater, done);
        }
      }, {
        key: 'selectPrevious',
        value: function selectPrevious(done) {
          var updater;
          updater = function updater(state) {
            var index, newSelected;
            if (state.selected) {
              index = Math.max(0, state.keys.indexOf(state.selected));
            }
            newSelected = state.keys[index - 1] || state.keys[state.keys.length - 1];
            return {
              selected: newSelected
            };
          };
          return this.setState(updater, done);
        }
      }, {
        key: 'handleKey',
        value: function handleKey(event) {
          var base, ref;
          boundMethodCheck(this, ContextList);
          if ((ref = event.keyCode) === DOWN || ref === RIGHT || ref === TAB || ref === UP || ref === LEFT) {
            event.preventDefault();
          }
          switch (event.keyCode) {
            case DOWN:
            case RIGHT:
            case TAB:
              return this.selectNext();
            case UP:
            case LEFT:
              return this.selectPrevious();
            case ENTER:
            case SPACE:
              if (this.state.selected != null) {
                event.preventDefault();
                return typeof (base = this.props).onSelect === "function" ? base.onSelect(this.state.selected, this.props.options) : void 0;
              }
          }
        }
      }, {
        key: 'handleClick',
        value: function handleClick(key, event) {
          var base;
          // Prevents from double events - e.g.: both onClick on item and onSelect would be triggered
          event.preventDefault();
          event.stopPropagation();
          this.setState({
            selected: key
          });
          return typeof (base = this.props).onSelect === "function" ? base.onSelect(key, this.props.options) : void 0;
        }
      }, {
        key: 'handleMouseEnter',
        value: function handleMouseEnter(key, event) {
          return this.setState({
            selected: key
          });
        }
      }, {
        key: 'handleMouseLeave',
        value: function handleMouseLeave(event) {
          var base;
          boundMethodCheck(this, ContextList);
          this.setState({
            selected: null
          });
          return typeof (base = this.props).onMouseLeave === "function" ? base.onMouseLeave(event) : void 0;
        }
      }, {
        key: 'renderOption',
        value: function renderOption(key) {
          var className, getOption;
          boundMethodCheck(this, ContextList);
          className = classNames('c-context_list-item', {
            'is-selected': this.state.selected === key
          });
          getOption = this.props.getOption || defaultGetOption;
          return React.createElement(
            'li',
            { key: key, className: className, onClick: this.handleClick.bind(this, key), onMouseEnter: this.handleMouseEnter.bind(this, key) },
            getOption(key, this.props.options)
          );
        }
      }, {
        key: 'render',
        value: function render() {
          var className, cleanProps;
          className = classNames('c-context_list', this.props.className, {
            'is-active': this.state.isActive
          });
          cleanProps = omit(this.props, 'className', 'children', 'options', 'getOption', 'onSelect');
          return React.createElement(
            'ul',
            (0, _extends3.default)({}, cleanProps, { className: className, onMouseLeave: this.handleMouseLeave }),
            this.state.keys.map(this.renderOption)
          );
        }
      }]);
      return ContextList;
    }(React.PureComponent);

    ;

    ContextList.defaultProps = {
      options: []
    };

    return ContextList;
  }();

  module.exports = ContextList;
}).call(undefined);