'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _keymanager = require('nebenan-helpers/lib/keymanager');

var _keymanager2 = _interopRequireDefault(_keymanager);

var _base_component = require('nebenan-base-class/lib/base_component');

var _base_component2 = _interopRequireDefault(_base_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ContextMenu = function (_BaseComponent) {
  (0, _inherits3.default)(ContextMenu, _BaseComponent);

  function ContextMenu(props) {
    (0, _classCallCheck3.default)(this, ContextMenu);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ContextMenu.__proto__ || Object.getPrototypeOf(ContextMenu)).call(this, props));

    _this.state = { isActive: false };
    _this.bindToComponent('handleGlobalClick', 'hide', 'show', 'toggle');
    return _this;
  }

  (0, _createClass3.default)(ContextMenu, [{
    key: 'activate',
    value: function activate() {
      if (this.isListenerActive) return;
      this.stopListeningToKeys = (0, _keymanager2.default)('esc', this.hide);
      document.addEventListener('click', this.handleGlobalClick);
      this.isListenerActive = true;
    }
  }, {
    key: 'deactivate',
    value: function deactivate() {
      if (!this.isListenerActive) return;
      this.stopListeningToKeys();
      document.removeEventListener('click', this.handleGlobalClick);
      this.isListenerActive = false;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.defaultState) this.show();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.deactivate();
    }
  }, {
    key: 'handleGlobalClick',
    value: function handleGlobalClick(event) {
      // click registered before rendering/after unmounting was complete
      if (!this.els.container) return;
      if (!this.els.container.contains(event.target)) this.hide();
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.deactivate();
      if (this.isActive()) this.setState({ isActive: false }, this.props.onHide);
    }
  }, {
    key: 'show',
    value: function show() {
      this.activate();
      if (!this.isActive()) this.setState({ isActive: true }, this.props.onShow);
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      if (this.isActive()) return this.hide();
      this.show();
    }
  }, {
    key: 'isActive',
    value: function isActive() {
      return this.state.isActive;
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-context_menu', this.props.className, {
        'is-active': this.state.isActive
      });

      var cleanProps = (0, _omit2.default)(this.props, 'children', 'label', 'defaultState', 'onHide', 'onShow');
      var label = _react2.default.createElement(
        'header',
        { className: 'c-context_menu-label', onClick: this.toggle },
        this.props.label
      );

      return _react2.default.createElement(
        'aside',
        (0, _extends3.default)({}, cleanProps, { className: className, ref: this.setEl('container') }),
        label,
        this.props.children
      );
    }
  }]);
  return ContextMenu;
}(_base_component2.default);

ContextMenu.propTypes = {
  className: _propTypes2.default.string,
  label: _propTypes2.default.node,
  defaultState: _propTypes2.default.bool,
  onHide: _propTypes2.default.func,
  onShow: _propTypes2.default.func,
  children: _propTypes2.default.node
};

exports.default = ContextMenu;