'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var Datepicker,
      Input,
      InputProxyComponent,
      PropTypes,
      React,
      classNames,
      eventproxy,
      keymanager,
      omit,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  PropTypes = require('prop-types');

  omit = require('lodash/omit');

  classNames = require('classnames');

  keymanager = require('nebenan-helpers/lib/keymanager').default;

  eventproxy = require('nebenan-helpers/lib/eventproxy').default;

  InputProxyComponent = require('nebenan-base-class/lib/input_proxy_component');

  Input = require('../input');

  Datepicker = function () {
    var Datepicker = function (_InputProxyComponent) {
      (0, _inherits3.default)(Datepicker, _InputProxyComponent);

      function Datepicker() {
        (0, _classCallCheck3.default)(this, Datepicker);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Datepicker.__proto__ || Object.getPrototypeOf(Datepicker)).apply(this, arguments));

        _this.handleGlobalClick = _this.handleGlobalClick.bind(_this);
        _this.hide = _this.hide.bind(_this);
        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.handleClick = _this.handleClick.bind(_this);
        return _this;
      }

      (0, _createClass3.default)(Datepicker, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.deactivate();
          return (0, _get3.default)(Datepicker.prototype.__proto__ || Object.getPrototypeOf(Datepicker.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'handleGlobalClick',
        value: function handleGlobalClick(event) {
          var isOutside;
          boundMethodCheck(this, Datepicker);
          if (!this.isComponentMounted) {
            return;
          }
          isOutside = !this.refs.container.contains(event.target);
          if (isOutside) {
            this.hide();
          }
          if (!this.refs.input.isPristine() && isOutside) {
            return this.refs.input.validate();
          }
        }
      }, {
        key: 'activate',
        value: function activate() {
          var Pikaday, options;
          if (this.isActive) {
            return;
          }
          Pikaday = require('pikaday');
          options = {
            firstDay: 1,
            field: this.refs.input.getInput(),
            format: this.props.format || 'L',
            i18n: this.context.localeData.modules.calendar,
            yearRange: [],
            bound: false,
            onSelect: this.handleSelect
          };
          if (this.props.minDate) {
            options.minDate = new Date(this.props.minDate);
          }
          if (this.props.maxDate) {
            options.maxDate = new Date(this.props.maxDate);
          }
          if (this.props.yearRange) {
            options.yearRange = this.props.yearRange;
          }
          this.picker = new Pikaday(options);
          this.picker.hide(); // picker thinks it's visible by default. it ain't.
          this.stopListeningToKeys = keymanager('esc', this.hide);
          this.stopListeningToClicks = eventproxy('click', this.handleGlobalClick);
          if (this.props.defaultValue) {
            // Fixes glitch when defaultValue is out of min/max bounds
            this.setDefaultValue();
          }
          return this.isActive = true;
        }
      }, {
        key: 'deactivate',
        value: function deactivate() {
          if (!this.isActive) {
            return;
          }
          this.stopListeningToKeys();
          this.stopListeningToClicks();
          this.picker.destroy();
          return this.isActive = false;
        }
      }, {
        key: 'show',
        value: function show() {
          if (this.picker.isVisible()) {
            return;
          }
          return this.picker.show();
        }
      }, {
        key: 'hide',
        value: function hide() {
          boundMethodCheck(this, Datepicker);
          if (!this.picker.isVisible()) {
            return;
          }
          return this.picker.hide();
        }
      }, {
        key: 'setDefaultValue',
        value: function setDefaultValue() {
          var value;
          value = this.picker.toString();
          if (this.props.defaultValue !== value) {
            return this.refs.input.setValue(value);
          }
        }
      }, {
        key: 'handleSelect',
        value: function handleSelect() {
          var value;
          boundMethodCheck(this, Datepicker);
          value = this.picker.toString();
          this.refs.input.setValue(value, this.refs.input.validate);
          return this.hide();
        }
      }, {
        key: 'handleClick',
        value: function handleClick(event) {
          boundMethodCheck(this, Datepicker);
          if (event.target.tagName.toLowerCase() === 'select') {
            // Clicking on picker UI
            return;
          }
          this.activate();
          if (this.picker.isVisible()) {
            return this.hide();
          } else {
            return this.show();
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var className, cleanProps;
          className = classNames('c-datepicker', this.props.className);
          cleanProps = omit(this.props, 'format', 'minDate', 'maxDate', 'yearRange');
          return React.createElement(
            'article',
            { ref: 'container', className: className, onClick: this.handleClick },
            React.createElement(Input, (0, _extends3.default)({}, cleanProps, { ref: 'input', readOnly: true }))
          );
        }
      }]);
      return Datepicker;
    }(InputProxyComponent);

    ;

    Datepicker.contextTypes = {
      localeData: PropTypes.object
    };

    return Datepicker;
  }();

  module.exports = Datepicker;
}).call(undefined);