'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _base_component = require('nebenan-base-class/lib/base_component');

var _base_component2 = _interopRequireDefault(_base_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Draggable = function (_BaseComponent) {
  (0, _inherits3.default)(Draggable, _BaseComponent);

  function Draggable(props) {
    (0, _classCallCheck3.default)(this, Draggable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Draggable.__proto__ || Object.getPrototypeOf(Draggable)).call(this, props));

    _this.bindToComponent('handleTouchStart', 'handleMouseDown', 'handleMove', 'handleStop');
    return _this;
  }

  (0, _createClass3.default)(Draggable, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.deactivateMouse();
      this.deactivateTouch();
    }
  }, {
    key: 'getNode',
    value: function getNode() {
      return this.els.node;
    }
  }, {
    key: 'activateMouse',
    value: function activateMouse() {
      if (this.isMouseActive) return;
      document.addEventListener('mousemove', this.handleMove);
      document.addEventListener('mouseup', this.handleStop);
      this.isMouseActive = true;
    }
  }, {
    key: 'deactivateMouse',
    value: function deactivateMouse() {
      if (!this.isMouseActive) return;
      document.removeEventListener('mousemove', this.handleMove);
      document.removeEventListener('mouseup', this.handleStop);
      this.isMouseActive = false;
    }
  }, {
    key: 'activateTouch',
    value: function activateTouch() {
      if (this.isTouchActive) return;
      document.addEventListener('touchmove', this.handleMove);
      document.addEventListener('touchend', this.handleStop);
      this.isTouchActive = true;
    }
  }, {
    key: 'deactivateTouch',
    value: function deactivateTouch() {
      if (!this.isTouchActive) return;
      document.removeEventListener('touchmove', this.handleMove);
      document.removeEventListener('touchend', this.handleStop);
      this.isTouchActive = false;
    }
  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(event) {
      this.activateTouch();
      if (this.props.onTouchStart) this.props.onTouchStart(event);
      if (this.props.onDragStart) this.props.onDragStart(event);
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(event) {
      this.activateMouse();
      if (this.props.onMouseDown) this.props.onMouseDown(event);
      if (this.props.onDragStart) this.props.onDragStart(event);
    }
  }, {
    key: 'handleMove',
    value: function handleMove(event) {
      if (this.props.onDrag) this.props.onDrag(event);
    }
  }, {
    key: 'handleStop',
    value: function handleStop(event) {
      this.deactivateTouch();
      this.deactivateMouse();
      if (this.props.onDragStop) this.props.onDragStop(event);
    }
  }, {
    key: 'render',
    value: function render() {
      var cleanProps = (0, _omit2.default)(this.props, 'onDragStart', 'onDrag', 'onDragStop');

      return _react2.default.createElement('div', (0, _extends3.default)({}, cleanProps, {
        ref: this.setEl('node'),
        onTouchStart: this.handleTouchStart,
        onMouseDown: this.handleMouseDown
      }));
    }
  }]);
  return Draggable;
}(_base_component2.default);

Draggable.propTypes = {
  onDragStart: _propTypes2.default.func.isRequired,
  onDrag: _propTypes2.default.func.isRequired,
  onDragStop: _propTypes2.default.func.isRequired
};

exports.default = Draggable;