'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var DraggableBox,
      React,
      TRIGGER_DISTANCE,
      TRIGGER_TIMEOUT,
      classNames,
      eventCoordinates,
      getPrefixed,
      omit,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  classNames = require('classnames');

  omit = require('lodash/omit');

  var _require = require('nebenan-helpers/lib/utils/dom');

  getPrefixed = _require.getPrefixed;
  eventCoordinates = _require.eventCoordinates;


  TRIGGER_DISTANCE = 20;

  TRIGGER_TIMEOUT = 500;

  DraggableBox = function (_React$PureComponent) {
    (0, _inherits3.default)(DraggableBox, _React$PureComponent);

    function DraggableBox(props) {
      (0, _classCallCheck3.default)(this, DraggableBox);

      var _this = (0, _possibleConstructorReturn3.default)(this, (DraggableBox.__proto__ || Object.getPrototypeOf(DraggableBox)).call(this, props));

      _this.handleDragStart = _this.handleDragStart.bind(_this);
      _this.handleDragMove = _this.handleDragMove.bind(_this);
      _this.handleDragEnd = _this.handleDragEnd.bind(_this);
      _this.handleDelayedStart = _this.handleDelayedStart.bind(_this);
      _this.handleSwipeStart = _this.handleSwipeStart.bind(_this);
      _this.handleSwipeMove = _this.handleSwipeMove.bind(_this);
      _this.handleSwipeEnd = _this.handleSwipeEnd.bind(_this);
      _this.state = _this.getDefaultState();
      return _this;
    }

    (0, _createClass3.default)(DraggableBox, [{
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.deactivateDrag();
        return this.deactivateSwipe();
      }
    }, {
      key: 'getDefaultState',
      value: function getDefaultState() {
        return {
          active: false,
          x: null,
          y: null
        };
      }
    }, {
      key: 'activateDrag',
      value: function activateDrag() {
        if (this.isActive) {
          return;
        }
        document.addEventListener('mousemove', this.handleDragMove);
        document.addEventListener('mouseup', this.handleDragEnd);
        return this.isActive = true;
      }
    }, {
      key: 'deactivateDrag',
      value: function deactivateDrag() {
        if (!this.isActive) {
          return;
        }
        document.removeEventListener('mousemove', this.handleDragMove);
        document.removeEventListener('mouseup', this.handleDragEnd);
        return this.isActive = false;
      }
    }, {
      key: 'activateSwipe',
      value: function activateSwipe() {
        if (this.isActive) {
          return;
        }
        document.addEventListener('touchmove', this.handleSwipeMove);
        document.addEventListener('touchend', this.handleSwipeEnd);
        return this.isActive = true;
      }
    }, {
      key: 'deactivateSwipe',
      value: function deactivateSwipe() {
        if (!this.isActive) {
          return;
        }
        document.removeEventListener('touchmove', this.handleSwipeMove);
        document.removeEventListener('touchend', this.handleSwipeEnd);
        return this.isActive = false;
      }
    }, {
      key: 'handleMoveStart',
      value: function handleMoveStart(event) {
        var pageX, pageY;

        var _eventCoordinates = eventCoordinates(event, 'pageX', 'pageY');

        pageX = _eventCoordinates.pageX;
        pageY = _eventCoordinates.pageY;

        this.startX = pageX;
        return this.startY = pageY;
      }
    }, {
      key: 'handleMoveEnd',
      value: function handleMoveEnd() {
        var _this2 = this;

        var complete, wasActive;
        wasActive = this.state.active;
        complete = function complete() {
          var base;
          if (wasActive) {
            return typeof (base = _this2.props).onMoveEnd === "function" ? base.onMoveEnd() : void 0;
          }
        };
        return this.setState(this.getDefaultState(), complete);
      }
    }, {
      key: 'handleDragStart',
      value: function handleDragStart(event) {
        var base;
        boundMethodCheck(this, DraggableBox);
        this.activateDrag();
        this.handleMoveStart(event);
        return typeof (base = this.props).onMouseDown === "function" ? base.onMouseDown(event) : void 0;
      }
    }, {
      key: 'handleDragMove',
      value: function handleDragMove(event) {
        var _this3 = this;

        var pageX, pageY, updater, x, y;
        boundMethodCheck(this, DraggableBox);
        pageX = event.pageX;
        pageY = event.pageY;

        x = pageX - this.startX;
        y = pageY - this.startY;
        updater = function updater(state) {
          var base, base1;
          if (state.active) {
            if (typeof (base = _this3.props).onMove === "function") {
              base.onMove(pageX, pageY, x, y);
            }
            return { x: x, y: y };
          } else if (Math.abs(x) > TRIGGER_DISTANCE || Math.abs(y) > TRIGGER_DISTANCE) {
            if (typeof (base1 = _this3.props).onMoveStart === "function") {
              base1.onMoveStart(_this3.startX, _this3.startY);
            }
            return {
              active: true
            };
          }
        };
        return this.setState(updater);
      }
    }, {
      key: 'handleDragEnd',
      value: function handleDragEnd(event) {
        boundMethodCheck(this, DraggableBox);
        this.deactivateDrag();
        this.handleMoveEnd();
        return this.startX = this.startY = null;
      }
    }, {
      key: 'handleDelayedStart',
      value: function handleDelayedStart() {
        var base;
        boundMethodCheck(this, DraggableBox);
        this.setState({
          active: true
        });
        return typeof (base = this.props).onMoveStart === "function" ? base.onMoveStart(this.startX, this.startY) : void 0;
      }
    }, {
      key: 'handleSwipeStart',
      value: function handleSwipeStart(event) {
        var base;
        boundMethodCheck(this, DraggableBox);
        this.activateSwipe();
        this.startTime = Date.now();
        this.startTid = setTimeout(this.handleDelayedStart, TRIGGER_TIMEOUT);
        this.handleMoveStart(event);
        return typeof (base = this.props).onTouchStart === "function" ? base.onTouchStart(event) : void 0;
      }
    }, {
      key: 'handleSwipeMove',
      value: function handleSwipeMove(event) {
        var base, pageX, pageY, x, y;
        boundMethodCheck(this, DraggableBox);
        if (Date.now() - this.startTime < TRIGGER_TIMEOUT) {
          clearTimeout(this.startTid);
          this.deactivateSwipe();
          return;
        }
        event.preventDefault();

        var _eventCoordinates2 = eventCoordinates(event, 'pageX', 'pageY');

        pageX = _eventCoordinates2.pageX;
        pageY = _eventCoordinates2.pageY;

        x = pageX - this.startX;
        y = pageY - this.startY;
        this.setState({ x: x, y: y });
        return typeof (base = this.props).onMove === "function" ? base.onMove(pageX, pageY, x, y) : void 0;
      }
    }, {
      key: 'handleSwipeEnd',
      value: function handleSwipeEnd(event) {
        boundMethodCheck(this, DraggableBox);
        this.deactivateSwipe();
        this.handleMoveEnd();
        return this.startX = this.startY = this.startTime = this.startTid = null;
      }
    }, {
      key: 'render',
      value: function render() {
        var className, cleanProps, style;
        className = classNames('c-draggable_box', this.props.className, {
          'is-active': this.state.active
        });
        cleanProps = omit(this.props, 'children', 'onMoveStart', 'onMove', 'onMoveEnd');
        if (this.state.active) {
          style = getPrefixed({
            transform: 'translate3d(' + this.state.x + 'px, ' + this.state.y + 'px, 0) scale(1.2)'
          });
        }
        return React.createElement(
          'div',
          (0, _extends3.default)({}, cleanProps, { className: className, style: style, onMouseDown: this.handleDragStart, onTouchStart: this.handleSwipeStart }),
          this.props.children
        );
      }
    }]);
    return DraggableBox;
  }(React.PureComponent);

  module.exports = DraggableBox;
}).call(undefined);