'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _data = require('nebenan-helpers/lib/utils/data');

var _dom = require('nebenan-helpers/lib/utils/dom');

var _base_component = require('nebenan-base-class/lib/base_component');

var _base_component2 = _interopRequireDefault(_base_component);

var _context_menu = require('../context_menu');

var _context_menu2 = _interopRequireDefault(_context_menu);

var _context_list = require('../context_list');

var _context_list2 = _interopRequireDefault(_context_list);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultGetOption = function defaultGetOption(key, items) {
  var item = items[key];
  var className = (0, _classnames2.default)('c-dropdown-option', {
    'ui-link': item.href || item.callback
  });

  return _react2.default.createElement(
    'span',
    { className: className },
    item.text
  );
};

var Dropdown = function (_BaseComponent) {
  (0, _inherits3.default)(Dropdown, _BaseComponent);

  function Dropdown(props) {
    (0, _classCallCheck3.default)(this, Dropdown);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.state = {
      isRight: false,
      isTop: false,
      isActive: false
    };

    _this.bindToComponent('show', 'hide', 'handleShow', 'handleHide', 'handleSelect');
    return _this;
  }

  (0, _createClass3.default)(Dropdown, [{
    key: 'getPosition',
    value: function getPosition(props) {
      var isRight = props.positionRight,
          isTop = props.positionTop;

      var hasRightPosition = (0, _data.has)(props, 'positionRight');
      var hasTopPosition = (0, _data.has)(props, 'positionTop');

      if (hasRightPosition && hasTopPosition) return { isRight: isRight, isTop: isTop };

      var label = this.els.label;

      var _screenPosition = (0, _dom.screenPosition)(label),
          top = _screenPosition.top,
          left = _screenPosition.left;

      var _size = (0, _dom.size)(label),
          width = _size.width,
          height = _size.height;

      var _screenSize = (0, _dom.screenSize)(global),
          sWidth = _screenSize.width,
          sHeight = _screenSize.height;

      if (!hasRightPosition) isRight = left + width < sWidth - left;
      if (!hasTopPosition) isTop = top + height > sHeight - top;

      return { isRight: isRight, isTop: isTop };
    }
  }, {
    key: 'show',
    value: function show() {
      this.els.menu.show();
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.els.menu.hide();
    }
  }, {
    key: 'handleShow',
    value: function handleShow() {
      var _this2 = this;

      var list = this.els.list;

      if (list) list.activate();

      var updater = function updater(state, props) {
        var _getPosition = _this2.getPosition(props),
            isRight = _getPosition.isRight,
            isTop = _getPosition.isTop;

        return { isActive: true, isRight: isRight, isTop: isTop };
      };

      this.setState(updater, this.props.onShow);
    }
  }, {
    key: 'handleHide',
    value: function handleHide() {
      var list = this.els.list;

      if (list) list.deactivate();
      this.setState({ isActive: false }, this.props.onHide);
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(key) {
      var _props$options$key = this.props.options[key],
          href = _props$options$key.href,
          callback = _props$options$key.callback,
          preventClosing = _props$options$key.preventClosing;

      if (href) this.context.router.push(href);
      if (callback) callback(key);
      if (!preventClosing) this.hide();
    }
  }, {
    key: 'renderList',
    value: function renderList() {
      var getOption = this.props.getOption || defaultGetOption;
      var onSelect = this.props.onSelect || this.handleSelect;

      return _react2.default.createElement(_context_list2.default, {
        ref: this.setEl('list'), className: 'ui-options',
        options: this.props.options, getOption: getOption,
        onSelect: onSelect
      });
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      return _react2.default.createElement(
        'span',
        { className: 'ui-link' },
        this.t('generic.more'),
        ' ',
        _react2.default.createElement('i', { className: 'icon-arrow_down' })
      );
    }
  }, {
    key: 'renderCloseLabel',
    value: function renderCloseLabel() {
      var closeLabel = this.props.closeLabel;

      if ((0, _data.has)(this.props, 'closeLabel') && !closeLabel) return null;

      var label = closeLabel;
      if (!label) {
        label = _react2.default.createElement(
          'small',
          null,
          this.t('generic.close'),
          ' ',
          _react2.default.createElement('i', { className: 'icon-cross' })
        );
      }

      return _react2.default.createElement(
        'div',
        { className: 'c-dropdown-close ui-link', onClick: this.hide },
        label
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          isActive = _state.isActive,
          isRight = _state.isRight,
          isTop = _state.isTop;
      var _props = this.props,
          label = _props.label,
          options = _props.options,
          children = _props.children;


      var className = (0, _classnames2.default)('c-dropdown', this.props.className, {
        'is-right': isRight,
        'is-top': isTop
      });

      var cleanProps = (0, _omit2.default)(this.props, 'children', 'options', 'getOption', 'onSelect', 'closeLabel', 'positionTop', 'positionRight');

      var menuLabel = _react2.default.createElement(
        'span',
        { className: 'c-dropdown-label', ref: this.setEl('label') },
        label || this.renderLabel()
      );

      var menuBody = void 0;
      if (isActive) {
        var menuContent = void 0;
        if (children) menuContent = _react2.default.createElement(
          'div',
          { className: 'c-dropdown-content' },
          children
        );

        menuBody = _react2.default.createElement(
          'div',
          { className: 'c-dropdown-body ui-card' },
          this.renderCloseLabel(),
          options && this.renderList(),
          menuContent
        );
      }

      return _react2.default.createElement(
        _context_menu2.default,
        (0, _extends3.default)({}, cleanProps, {
          className: className, ref: this.setEl('menu'),
          label: menuLabel, onShow: this.handleShow, onHide: this.handleHide
        }),
        menuBody
      );
    }
  }]);
  return Dropdown;
}(_base_component2.default);

Dropdown.contextTypes = {
  router: _propTypes2.default.object,
  locale: _propTypes2.default.object
};

Dropdown.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  onShow: _propTypes2.default.func,
  onHide: _propTypes2.default.func,

  options: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
  getOption: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,

  closeLabel: _propTypes2.default.node,
  label: _propTypes2.default.node,

  positionRight: _propTypes2.default.bool,
  positionTop: _propTypes2.default.bool
};

exports.default = Dropdown;