'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var BaseComponent,
      Dropzone,
      React,
      classNames,
      omit,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  omit = require('lodash/omit');

  classNames = require('classnames');

  BaseComponent = require('nebenan-base-class/lib/base_component');

  Dropzone = function (_BaseComponent) {
    (0, _inherits3.default)(Dropzone, _BaseComponent);

    function Dropzone(props) {
      (0, _classCallCheck3.default)(this, Dropzone);

      var _this = (0, _possibleConstructorReturn3.default)(this, (Dropzone.__proto__ || Object.getPrototypeOf(Dropzone)).call(this, props));

      _this.handleDragStart = _this.handleDragStart.bind(_this);
      _this.handleDragEnd = _this.handleDragEnd.bind(_this);
      _this.handleGlobalDrop = _this.handleGlobalDrop.bind(_this);
      _this.handleDragEnter = _this.handleDragEnter.bind(_this);
      _this.handleDragLeave = _this.handleDragLeave.bind(_this);
      _this.handleDragOver = _this.handleDragOver.bind(_this);
      _this.handleDrop = _this.handleDrop.bind(_this);
      _this.state = _this.getDefaultState();
      return _this;
    }

    (0, _createClass3.default)(Dropzone, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        return this.activate();
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        return this.deactivate();
      }
    }, {
      key: 'getDefaultState',
      value: function getDefaultState() {
        return {
          isActive: false,
          isHover: false
        };
      }
    }, {
      key: 'handleDragStart',
      value: function handleDragStart(event) {
        var base;
        boundMethodCheck(this, Dropzone);
        this.startedCounter++;
        if (this.startedCounter === 1) {
          this.setState({
            isActive: true
          });
          return typeof (base = this.props).onDragStart === "function" ? base.onDragStart(event) : void 0;
        }
      }
    }, {
      key: 'handleDragEnd',
      value: function handleDragEnd(event) {
        var base;
        boundMethodCheck(this, Dropzone);
        this.startedCounter--;
        if (this.startedCounter === 0) {
          this.setState({
            isActive: false
          });
          return typeof (base = this.props).onDragEnd === "function" ? base.onDragEnd(event) : void 0;
        }
      }
    }, {
      key: 'handleGlobalDrop',
      value: function handleGlobalDrop() {
        boundMethodCheck(this, Dropzone);
        return this.reset();
      }
    }, {
      key: 'handleDragEnter',
      value: function handleDragEnter(event) {
        var base;
        boundMethodCheck(this, Dropzone);
        this.enteredCounter++;
        if (this.enteredCounter === 1) {
          this.setState({
            isHover: true
          });
          return typeof (base = this.props).onDragEnter === "function" ? base.onDragEnter(event) : void 0;
        }
      }
    }, {
      key: 'handleDragLeave',
      value: function handleDragLeave(event) {
        var base;
        boundMethodCheck(this, Dropzone);
        this.enteredCounter--;
        if (this.enteredCounter === 0) {
          this.setState({
            isHover: false
          });
          return typeof (base = this.props).onDragLeave === "function" ? base.onDragLeave(event) : void 0;
        }
      }
    }, {
      key: 'handleDragOver',
      value: function handleDragOver(event) {
        var base;
        boundMethodCheck(this, Dropzone);
        event.preventDefault();
        event.stopPropagation();
        return typeof (base = this.props).onDragOver === "function" ? base.onDragOver(event) : void 0;
      }
    }, {
      key: 'handleDrop',
      value: function handleDrop(event) {
        var base, base1, files;
        boundMethodCheck(this, Dropzone);
        event.preventDefault();
        files = event.dataTransfer.files;

        if (files.length) {
          // dragging nodes around
          if (typeof (base = this.props).onSelect === "function") {
            base.onSelect(files);
          }
        }
        return typeof (base1 = this.props).onDrop === "function" ? base1.onDrop(event) : void 0;
      }
    }, {
      key: 'reset',
      value: function reset(done) {
        // counters are needed to handle insane enter/leave calls
        this.startedCounter = 0;
        this.enteredCounter = 0;
        return this.setState(this.getDefaultState(), done);
      }
    }, {
      key: 'activate',
      value: function activate() {
        this.reset();
        document.addEventListener('dragenter', this.handleDragStart);
        document.addEventListener('dragleave', this.handleDragEnd);
        return document.addEventListener('drop', this.handleGlobalDrop);
      }
    }, {
      key: 'deactivate',
      value: function deactivate() {
        document.removeEventListener('dragenter', this.handleDragStart);
        document.removeEventListener('dragleave', this.handleDragEnd);
        return document.removeEventListener('drop', this.handleGlobalDrop);
      }
    }, {
      key: 'render',
      value: function render() {
        var className, cleanProps;
        className = classNames('c-dropzone', this.props.className, {
          'is-active': this.state.isActive,
          'is-hover': this.state.isHover
        });
        cleanProps = omit(this.props, 'children', 'onSelect', 'onDragStart', 'onDragEnd');
        return React.createElement(
          'span',
          (0, _extends3.default)({}, cleanProps, { className: className, onDragOver: this.handleDragOver, onDragEnter: this.handleDragEnter, onDragLeave: this.handleDragLeave, onDrop: this.handleDrop }),
          this.props.children,
          React.createElement(
            'span',
            { className: 'c-dropzone-overlay' },
            React.createElement(
              'span',
              { className: 'c-dropzone-overlay-text-active' },
              this.t('dropzone.label_drag')
            ),
            React.createElement(
              'span',
              { className: 'c-dropzone-overlay-text-hover' },
              this.t('dropzone.label_release')
            )
          )
        );
      }
    }]);
    return Dropzone;
  }(BaseComponent);

  module.exports = Dropzone;
}).call(undefined);