'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _querystring = require('querystring');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EmailLink = function EmailLink(props) {
  var address = props.address,
      subject = props.subject,
      body = props.body,
      children = props.children,
      cleanProps = (0, _objectWithoutProperties3.default)(props, ['address', 'subject', 'body', 'children']);

  var query = (0, _querystring.stringify)({ subject: subject, body: body });

  var uri = 'mailto:' + address + '?' + query;
  var content = children || address;

  return _react2.default.createElement(
    'a',
    (0, _extends3.default)({}, cleanProps, { href: uri }),
    content
  );
};

exports.default = EmailLink;