'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _clamp = require('lodash/clamp');

var _clamp2 = _interopRequireDefault(_clamp);

var _heartbeat = require('nebenan-helpers/lib/heartbeat');

var _heartbeat2 = _interopRequireDefault(_heartbeat);

var _dots = require('../dots');

var _dots2 = _interopRequireDefault(_dots);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FadingSlideshow = function (_PureComponent) {
  (0, _inherits3.default)(FadingSlideshow, _PureComponent);

  function FadingSlideshow(props) {
    (0, _classCallCheck3.default)(this, FadingSlideshow);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FadingSlideshow.__proto__ || Object.getPrototypeOf(FadingSlideshow)).call(this, props));

    _this.state = {
      activeItemIndex: _this.props.defaultItemIndex
    };

    _this.setSlide = _this.setSlide.bind(_this);
    _this.rotate = _this.rotate.bind(_this);
    _this.renderItem = _this.renderItem.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FadingSlideshow, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.startAutoRotation();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.stopAutoRotation) this.stopAutoRotation();
    }
  }, {
    key: 'setSlide',
    value: function setSlide(index) {
      if (this.stopAutoRotation) this.stopAutoRotation();

      this.setState(function (state, props) {
        var validIndex = (0, _clamp2.default)(index, 0, props.items.length - 1);
        return { activeItemIndex: validIndex };
      }, this.startAutoRotation);
    }
  }, {
    key: 'startAutoRotation',
    value: function startAutoRotation() {
      this.stopAutoRotation = (0, _heartbeat2.default)(this.props.rotationInterval, this.rotate);
    }
  }, {
    key: 'rotate',
    value: function rotate() {
      var index = this.state.activeItemIndex + 1;
      if (index >= this.props.items.length) index = 0;

      this.setSlide(index);
    }
  }, {
    key: 'renderDots',
    value: function renderDots() {
      if (this.props.items.length > 1) {
        return _react2.default.createElement(_dots2.default, {
          count: this.props.items.length,
          active: this.state.activeItemIndex,
          onItemClick: this.setSlide
        });
      }
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, index) {
      var className = (0, _classnames2.default)('c-fading_slideshow-item', { 'is-active': this.state.activeItemIndex === index });
      return _react2.default.createElement(
        'span',
        { className: className },
        item
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-fading_slideshow', this.props.className);

      var _props = this.props,
          children = _props.children,
          items = _props.items;

      var cleanProps = (0, _omit2.default)(this.props, 'children', 'items', 'defaultItemIndex', 'rotationInterval');

      var content = _react.Children.map(items, this.renderItem);

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className }),
        content,
        this.renderDots(),
        children
      );
    }
  }]);
  return FadingSlideshow;
}(_react.PureComponent);

FadingSlideshow.defaultProps = {
  defaultItemIndex: 0,
  rotationInterval: 1000 * 15
};

exports.default = FadingSlideshow;