'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get3 = require('babel-runtime/helpers/get');

var _get4 = _interopRequireDefault(_get3);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _input_component = require('nebenan-base-class/lib/input_component');

var _input_component2 = _interopRequireDefault(_input_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FancySelect = function (_InputComponent) {
  (0, _inherits3.default)(FancySelect, _InputComponent);

  function FancySelect(props) {
    (0, _classCallCheck3.default)(this, FancySelect);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FancySelect.__proto__ || Object.getPrototypeOf(FancySelect)).call(this, props));

    _this.bindToComponent('renderOption');
    return _this;
  }

  (0, _createClass3.default)(FancySelect, [{
    key: 'getDefaultState',
    value: function getDefaultState(props) {
      var state = (0, _get4.default)(FancySelect.prototype.__proto__ || Object.getPrototypeOf(FancySelect.prototype), 'getDefaultState', this).call(this, props);
      if (state.value) state.index = props.options.findIndex(function (_ref) {
        var value = _ref.value;
        return value === state.value;
      });
      if (state.index === -1) state.value = null;
      return state;
    }
  }, {
    key: 'setValue',
    value: function setValue(newValue) {
      var _this2 = this;

      for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        rest[_key - 1] = arguments[_key];
      }

      if (!this.isComponentMounted) return;

      var updater = function updater(state, props) {
        var index = props.options.findIndex(function (_ref2) {
          var value = _ref2.value;
          return value === newValue;
        });
        return { index: index };
      };
      var complete = function complete() {
        var _get2;

        return (_get2 = (0, _get4.default)(FancySelect.prototype.__proto__ || Object.getPrototypeOf(FancySelect.prototype), 'setValue', _this2)).call.apply(_get2, [_this2, newValue].concat(rest));
      };

      this.setState(updater, complete);
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(index) {
      var value = this.props.options[index].value;

      if (this.state.value === value) value = null;
      this.setValue(value, this.validate);
    }
  }, {
    key: 'renderOption',
    value: function renderOption(_ref3, index) {
      var key = _ref3.key,
          imageClass = _ref3.imageClass;

      var className = (0, _classnames2.default)('c-fancy_select-item', {
        'is-active': index === this.state.index
      });

      var handler = this.handleSelect.bind(this, index);

      return _react2.default.createElement(
        'li',
        { key: key, className: className, onClick: handler },
        _react2.default.createElement('i', { className: imageClass }),
        key
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var hasError = this.isErrorActive();
      var className = (0, _classnames2.default)('c-fancy_select', this.props.className, {
        'is-error': hasError
      });
      var cleanProps = (0, _omit2.default)(this.props, 'label', 'error', 'options', 'children', 'defaultValue', 'onUpdate', 'children');

      var _props = this.props,
          label = _props.label,
          options = _props.options,
          children = _props.children;


      var error = void 0;
      if (hasError) error = _react2.default.createElement(
        'em',
        { className: 'ui-error' },
        this.getError()
      );

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className }),
        _react2.default.createElement(
          'strong',
          { className: 'ui-label' },
          label
        ),
        _react2.default.createElement(
          'ul',
          { className: 'c-fancy_select-list' },
          options.map(this.renderOption)
        ),
        children,
        error
      );
    }
  }]);
  return FancySelect;
}(_input_component2.default);

FancySelect.defaultProps = {
  options: []
};

FancySelect.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  options: _propTypes2.default.array.isRequired,

  validate: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),

  required: _propTypes2.default.bool,
  pattern: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,

  error: _propTypes2.default.string,
  name: _propTypes2.default.string,

  onUpdate: _propTypes2.default.func,
  onError: _propTypes2.default.func
};

exports.default = FancySelect;