'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var Infinite,
      InteractiveComponent,
      LoadingSpinner,
      OFFSET,
      PropTypes,
      React,
      SCROLL_RATE,
      classNames,
      documentOffset,
      eventproxy,
      offset,
      omit,
      scroll,
      size,
      throttle,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  PropTypes = require('prop-types');

  InteractiveComponent = require('nebenan-base-class/lib/interactive_component');

  omit = require('lodash/omit');

  throttle = require('lodash/throttle');

  classNames = require('classnames');

  eventproxy = require('nebenan-helpers/lib/eventproxy').default;

  var _require = require('nebenan-helpers/lib/utils/dom');

  scroll = _require.scroll;
  documentOffset = _require.documentOffset;
  size = _require.size;
  offset = _require.offset;

  var _require2 = require('../loading');

  LoadingSpinner = _require2.LoadingSpinner;


  SCROLL_RATE = 100;

  OFFSET = 150;

  Infinite = function () {
    var Infinite = function (_InteractiveComponent) {
      (0, _inherits3.default)(Infinite, _InteractiveComponent);

      function Infinite() {
        (0, _classCallCheck3.default)(this, Infinite);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Infinite.__proto__ || Object.getPrototypeOf(Infinite)).apply(this, arguments));

        _this.startScroller = _this.startScroller.bind(_this);
        _this.checkViewportPosition = _this.checkViewportPosition.bind(_this);
        return _this;
      }

      (0, _createClass3.default)(Infinite, [{
        key: 'startScroller',
        value: function startScroller() {
          boundMethodCheck(this, Infinite);
          this.activate();
          return this.checkViewportPosition();
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          (0, _get3.default)(Infinite.prototype.__proto__ || Object.getPrototypeOf(Infinite.prototype), 'componentDidMount', this).call(this);
          return process.nextTick(this.startScroller); // pause to render to get refs
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.deactivate();
          return (0, _get3.default)(Infinite.prototype.__proto__ || Object.getPrototypeOf(Infinite.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
          if (this.props.loading) {
            return this.deactivate();
          } else {
            return process.nextTick(this.startScroller); // pause to render to get refs
          }
        }
      }, {
        key: 'activate',
        value: function activate() {
          var base;
          if (!this.isComponentMounted) {
            return;
          }
          if (this.isActive) {
            return;
          }
          this.scrolledNode = (typeof (base = this.props).getScrolledNode === "function" ? base.getScrolledNode() : void 0) || global;
          this.handleScroll = throttle(this.checkViewportPosition, SCROLL_RATE);
          this.scroll = scroll(this.scrolledNode);
          this.scrolledNode.addEventListener('scroll', this.handleScroll);
          this.stopListeningToResize = eventproxy('resize', this.checkViewportPosition);
          return this.isActive = true;
        }
      }, {
        key: 'deactivate',
        value: function deactivate() {
          if (!this.isComponentMounted) {
            return;
          }
          if (!this.isActive) {
            return;
          }
          this.scrolledNode.removeEventListener('scroll', this.handleScroll);
          this.stopListeningToResize();
          return this.isActive = false;
        }
      }, {
        key: 'checkViewportPosition',
        value: function checkViewportPosition() {
          var base, globalOffset, nodeOffset, nodeOffsetTop, triggerOffset;
          boundMethodCheck(this, Infinite);
          if (!this.isComponentMounted) {
            return;
          }
          if (this.props.loading) {
            return;
          }
          triggerOffset = this.props.triggerOffset || OFFSET;
          globalOffset = this.scroll.get() + size(document.body).height;
          if (this.props.getScrolledNode) {
            nodeOffsetTop = offset(this.refs.container).top;
          } else {
            nodeOffsetTop = documentOffset(global, this.refs.container).top;
          }
          nodeOffset = nodeOffsetTop + size(this.refs.container).height;
          if (nodeOffset - globalOffset < triggerOffset) {
            this.deactivate();
            return typeof (base = this.props).onActive === "function" ? base.onActive() : void 0;
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var className, cleanProps, loadingKlass;
          cleanProps = omit(this.props, 'triggerOffset', 'loading', 'onActive', 'getScrolledNode');
          className = classNames('c-infinite', this.props.className);
          loadingKlass = classNames('c-infinite-loading', {
            'is-active': this.props.loading
          });
          return React.createElement(
            'aside',
            (0, _extends3.default)({}, cleanProps, { className: className, ref: 'container' }),
            React.createElement(
              'div',
              { className: loadingKlass },
              this.props.children || React.createElement(LoadingSpinner, null)
            )
          );
        }
      }]);
      return Infinite;
    }(InteractiveComponent);

    ;

    Infinite.propTypes = {
      loading: PropTypes.bool
    };

    return Infinite;
  }();

  module.exports = Infinite;
}).call(undefined);