'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get3 = require('babel-runtime/helpers/get');

var _get4 = _interopRequireDefault(_get3);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var ENTER,
      InputComponent,
      TextInputComponent,
      insertString,
      replaceString,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  var _require = require('nebenan-helpers/lib/constants/keys');

  ENTER = _require.ENTER;

  var _require2 = require('./utils');

  insertString = _require2.insertString;
  replaceString = _require2.replaceString;


  InputComponent = require('nebenan-base-class/lib/input_component');

  TextInputComponent = function (_InputComponent) {
    (0, _inherits3.default)(TextInputComponent, _InputComponent);

    function TextInputComponent() {
      (0, _classCallCheck3.default)(this, TextInputComponent);

      var _this = (0, _possibleConstructorReturn3.default)(this, (TextInputComponent.__proto__ || Object.getPrototypeOf(TextInputComponent)).apply(this, arguments));

      _this.focus = _this.focus.bind(_this);
      _this.blur = _this.blur.bind(_this);
      _this.handleKeyDown = _this.handleKeyDown.bind(_this);
      _this.insertValue = _this.insertValue.bind(_this);
      return _this;
    }

    (0, _createClass3.default)(TextInputComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        (0, _get4.default)(TextInputComponent.prototype.__proto__ || Object.getPrototypeOf(TextInputComponent.prototype), 'componentDidMount', this).call(this);
        return this.readDomValue();
      }
    }, {
      key: 'getDefaultState',
      value: function getDefaultState(props) {
        var state;
        state = (0, _get4.default)(TextInputComponent.prototype.__proto__ || Object.getPrototypeOf(TextInputComponent.prototype), 'getDefaultState', this).call(this, props);
        if (state.value == null) {
          state.value = '';
        }
        return state;
      }
    }, {
      key: 'getValue',
      value: function getValue() {
        return this.state.value.trim() || null;
      }
    }, {
      key: 'setValue',
      value: function setValue(value) {
        var _get2;

        if (value == null) {
          value = ''; // prevents from setting null
        }

        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        return (_get2 = (0, _get4.default)(TextInputComponent.prototype.__proto__ || Object.getPrototypeOf(TextInputComponent.prototype), 'setValue', this)).call.apply(_get2, [this, value].concat(args));
      }
    }, {
      key: 'getCaretPosition',
      value: function getCaretPosition() {
        return this.getInput().selectionEnd || this.state.value.length;
      }

      // Fixes the autofill feature in some of the dumbass browsers that are incapable of
      // triggering "change" event when they change values.

    }, {
      key: 'readDomValue',
      value: function readDomValue() {
        var value;

        var _getInput = this.getInput();

        value = _getInput.value;

        if (value !== this.state.value) {
          return this.setValue(value, this.validate);
        }
      }
    }, {
      key: 'focus',
      value: function focus() {
        boundMethodCheck(this, TextInputComponent);
        return this.getInput().focus();
      }
    }, {
      key: 'blur',
      value: function blur() {
        boundMethodCheck(this, TextInputComponent);
        return this.getInput().blur();
      }
    }, {
      key: 'setSelection',
      value: function setSelection(start, end) {
        if (end == null) {
          end = start;
        }
        return this.getInput().setSelectionRange(start, end);
      }
    }, {
      key: 'handleKeyDown',
      value: function handleKeyDown(event) {
        var base, base1, base2;
        boundMethodCheck(this, TextInputComponent);
        if (event.keyCode === ENTER && !event.ctrlKey) {
          if (event.shiftKey) {
            if (typeof (base = this.props).onShiftEnterKey === "function") {
              base.onShiftEnterKey(event);
            }
          } else {
            if (typeof (base1 = this.props).onEnterKey === "function") {
              base1.onEnterKey(event);
            }
          }
        }
        return typeof (base2 = this.props).onKeyDown === "function" ? base2.onKeyDown(event) : void 0;
      }
    }, {
      key: 'insertValue',
      value: function insertValue(text, done) {
        var _this2 = this;

        var caret, complete, position, result, value;
        boundMethodCheck(this, TextInputComponent);
        caret = this.getCaretPosition();
        value = this.state.value; // raw value to deal with emojis

        var _insertString = insertString(value, text, caret);

        result = _insertString.result;
        position = _insertString.position;

        complete = function complete() {
          _this2.focus();
          _this2.setSelection(position);
          return typeof done === "function" ? done() : void 0;
        };
        this.setValue(result, complete);
        return result;
      }
    }, {
      key: 'replaceValue',
      value: function replaceValue(pattern, replacement, done) {
        var _this3 = this;

        var caret, complete, position, result, value;
        caret = this.getCaretPosition();
        value = this.state.value; // raw value to deal with emojis

        var _replaceString = replaceString(value, pattern, replacement, caret);

        result = _replaceString.result;
        position = _replaceString.position;

        complete = function complete() {
          _this3.focus();
          _this3.setSelection(position);
          return typeof done === "function" ? done() : void 0;
        };
        this.setValue(result, complete);
        return result;
      }
    }]);
    return TextInputComponent;
  }(InputComponent);

  module.exports = TextInputComponent;
}).call(undefined);