'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _interactive_component = require('nebenan-base-class/lib/interactive_component');

var _interactive_component2 = _interopRequireDefault(_interactive_component);

var _utils = require('./utils');

var _dropdown = require('../dropdown');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _context_menu = require('../context_menu');

var _context_menu2 = _interopRequireDefault(_context_menu);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SEARCH_CHANGE_RATE = 300;

var ListControls = function (_InteractiveComponent) {
  (0, _inherits3.default)(ListControls, _InteractiveComponent);

  function ListControls(props) {
    (0, _classCallCheck3.default)(this, ListControls);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ListControls.__proto__ || Object.getPrototypeOf(ListControls)).call(this, props));

    _this.state = _this.getDefaultState(props);
    _this.bindToComponent('handleReset', 'handleDropdownToggle', 'handleSearchChange', 'handleSelect', 'handleDeactivateSearch', 'handleSearchShow');
    return _this;
  }

  (0, _createClass3.default)(ListControls, [{
    key: 'getDefaultState',
    value: function getDefaultState(props) {
      var value = (0, _utils.getValue)(props.defaultValue);
      var signature = (0, _utils.getSignature)(value);
      var hasDropdown = false;
      return { value: value, signature: signature, hasDropdown: hasDropdown };
    }
  }, {
    key: 'getSignature',
    value: function getSignature() {
      return this.state.signature;
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: 'setValue',
    value: function setValue(value, done) {
      var _this2 = this;

      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      var signature = (0, _utils.getSignature)(value);

      var updater = function updater(state) {
        if (state.signature !== signature) return { value: value, signature: signature };
        if (done) done();
        return null;
      };

      var complete = function complete() {
        if (_this2.props.onUpdate && !options.silent) _this2.props.onUpdate(value);
        if (done) done();
      };

      this.setState(updater, complete);
    }
  }, {
    key: 'handleReset',
    value: function handleReset() {
      var _this3 = this;

      var updater = function updater(state, props) {
        return _this3.getDefaultState(props);
      };
      var complete = function complete() {
        _this3.els.input.reset();
        if (_this3.props.onUpdate) _this3.props.onUpdate(_this3.getValue());
      };

      this.setState(updater, complete);
    }
  }, {
    key: 'handleDropdownToggle',
    value: function handleDropdownToggle() {
      this.setState(function (state) {
        return { hasDropdown: !state.hasDropdown };
      });
    }
  }, {
    key: 'handleSearchChange',
    value: function handleSearchChange() {
      var _this4 = this;

      if (!this.isComponentMounted) return false;

      var search = this.els.input.getValue();
      var value = (0, _extends4.default)({}, this.state.value, { search: search });
      var delayed = function delayed() {
        return _this4.setValue(value);
      };

      // Fixes race condition with input onChange. Will be fixed after React upgrade
      process.nextTick(delayed);
      return true;
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(type, index) {
      var item = this.props[type + 'Options'][index];
      var value = (0, _extends4.default)({}, this.state.value, (0, _defineProperty3.default)({}, type, item.value));
      this.setValue(value);
    }
  }, {
    key: 'handleDeactivateSearch',
    value: function handleDeactivateSearch() {
      this.els.search.hide();
    }
  }, {
    key: 'handleSearchShow',
    value: function handleSearchShow() {
      this.els.input.focus();
    }
  }, {
    key: 'getDropdownOption',
    value: function getDropdownOption(type, key, items) {
      var item = items[key];
      var isActive = item.value === this.state.value[type];
      var className = (0, _classnames2.default)('c-list_controls-option ui-link', {
        'is-active': isActive
      });
      return _react2.default.createElement(
        'span',
        { className: className },
        item.key
      );
    }
  }, {
    key: 'renderSearch',
    value: function renderSearch() {
      var className = (0, _classnames2.default)('c-list_controls-icon', {
        'is-active': this.state.value.search
      });
      var label = _react2.default.createElement(
        'span',
        { className: className },
        _react2.default.createElement('i', { className: 'icon-magnifier' })
      );

      return _react2.default.createElement(
        _context_menu2.default,
        {
          ref: this.setEl('search'),
          className: 'c-list_controls-search c-list_controls-item',
          onShow: this.handleSearchShow,
          label: label
        },
        _react2.default.createElement(
          'div',
          { className: 'c-list_controls-search_form' },
          _react2.default.createElement(
            'span',
            {
              className: 'c-list_controls-icon',
              onClick: this.handleDeactivateSearch
            },
            _react2.default.createElement('i', { className: 'icon-magnifier' })
          ),
          _react2.default.createElement(_input2.default, {
            ref: this.setEl('input'), type: 'search',
            onUpdate: (0, _debounce2.default)(this.handleSearchChange, SEARCH_CHANGE_RATE),
            onEnterKey: this.handleDeactivateSearch,
            placeholder: this.t('input.placeholder_search')
          })
        )
      );
    }
  }, {
    key: 'renderFilter',
    value: function renderFilter() {
      var className = (0, _classnames2.default)('c-list_controls-icon', {
        'is-active': this.state.value.filter
      });
      var label = _react2.default.createElement(
        'span',
        { className: className },
        _react2.default.createElement('i', { className: 'icon-funnel' })
      );

      return _react2.default.createElement(_dropdown2.default, {
        className: 'c-list_controls-item',
        label: label,
        closeLabel: false,
        options: (0, _utils.getOptions)('filter', this.props.filterOptions, this.handleSelect),
        getOption: this.getDropdownOption.bind(this, 'filter'),
        onShow: this.handleDropdownToggle, onHide: this.handleDropdownToggle
      });
    }
  }, {
    key: 'renderSort',
    value: function renderSort() {
      var className = (0, _classnames2.default)('c-list_controls-icon', {
        'is-active': this.state.value.sort
      });
      var label = _react2.default.createElement(
        'span',
        { className: className },
        _react2.default.createElement('i', { className: 'icon-list_sorting' })
      );

      return _react2.default.createElement(_dropdown2.default, {
        className: 'c-list_controls-item',
        label: label,
        closeLabel: false,
        options: (0, _utils.getOptions)('sort', this.props.sortOptions, this.handleSelect),
        getOption: this.getDropdownOption.bind(this, 'sort'),
        onShow: this.handleDropdownToggle, onHide: this.handleDropdownToggle
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-list_controls ui-card', this.props.className, {
        'has-dropdown': this.state.hasDropdown
      });

      var defaultState = this.getDefaultState(this.props);

      var resetLabel = void 0;
      if (defaultState.signature !== this.state.signature) {
        resetLabel = _react2.default.createElement(
          'span',
          { className: 'c-list_controls-reset ui-link', onClick: this.handleReset },
          _react2.default.createElement(
            'small',
            null,
            this.t('list_controls.reset')
          ),
          _react2.default.createElement('i', { className: 'icon-cross' })
        );
      }

      return _react2.default.createElement(
        'article',
        { className: className },
        this.renderSearch(),
        this.renderFilter(),
        this.renderSort(),
        resetLabel,
        this.props.children
      );
    }
  }]);
  return ListControls;
}(_interactive_component2.default);

ListControls.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  defaultValue: _propTypes2.default.object,
  onUpdate: _propTypes2.default.func,

  filterOptions: _propTypes2.default.array.isRequired,
  sortOptions: _propTypes2.default.array.isRequired
};

exports.default = ListControls;