'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getOptions = exports.getSignature = exports.isValueEmpty = exports.getValue = undefined;

var _data = require('nebenan-helpers/lib/utils/data');

var VALUE_PROPS = ['search', 'filter', 'sort'];

var defaultValue = {};
VALUE_PROPS.forEach(function (key) {
  defaultValue[key] = null;
});

var getValue = exports.getValue = function getValue(state) {
  if (!state) return defaultValue;

  var value = {};
  VALUE_PROPS.forEach(function (key) {
    value[key] = (0, _data.has)(state, key) ? state[key] : null;
  });
  return value;
};

var isValueEmpty = exports.isValueEmpty = function isValueEmpty(valueObj) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(valueObj)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      if (valueObj[key]) return false;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return true;
};

var getSignature = exports.getSignature = function getSignature(state) {
  if (isValueEmpty(state)) return null;
  return JSON.stringify(state);
};

var getOptions = exports.getOptions = function getOptions(type, optionsList, handler) {
  var callback = handler.bind(null, type);
  return optionsList.map(function (_ref) {
    var key = _ref.key,
        value = _ref.value;
    return { key: key, value: value, callback: callback };
  });
};