'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _map_component = require('nebenan-base-class/lib/map_component');

var _map_component2 = _interopRequireDefault(_map_component);

var _data = require('nebenan-helpers/lib/utils/data');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint react/no-unused-prop-types: "off" */
var Marker = function (_MapComponent) {
  (0, _inherits3.default)(Marker, _MapComponent);

  function Marker(props) {
    (0, _classCallCheck3.default)(this, Marker);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Marker.__proto__ || Object.getPrototypeOf(Marker)).call(this, props));

    _this.state = {
      isReady: false
    };
    return _this;
  }

  (0, _createClass3.default)(Marker, [{
    key: 'setMarker',
    value: function setMarker(marker) {
      this.marker = marker;
      this.setState({ isReady: Boolean(marker) });
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return { marker: this.marker };
    }
  }, {
    key: 'updateListener',
    value: function updateListener(props, nextProps, listener, prop) {
      if (props[prop] === nextProps[prop]) return;
      this.marker.off(listener);
      this.marker.on(listener, nextProps[prop]);
    }
  }, {
    key: 'update',
    value: function update(nextProps, nextContext) {
      if (nextProps.options !== this.props.options) {
        this.destroy();
        this.create(nextProps, nextContext);
        return;
      }

      var marker = this.marker;
      var position = nextProps.position,
          divIcon = nextProps.divIcon,
          defaultIcon = nextProps.icon,
          tooltip = nextProps.tooltip;


      if (position !== this.props.position) {
        marker.setLatLng((0, _data.reverse)(position));
      }

      if (divIcon !== this.props.divIcon || defaultIcon !== this.props.icon) {
        var icon = (0, _utils.getIcon)(this.leaflet, divIcon, defaultIcon);
        marker.setIcon(icon);
      }

      if (this.props.tooltip !== tooltip) {
        marker.unbindTooltip();
        marker.bindTooltip(tooltip);
      }

      this.updateListener(this.props, nextProps, 'click', 'onClick');
      this.updateListener(this.props, nextProps, 'popupopen', 'onPopupOpen');
      this.updateListener(this.props, nextProps, 'popupclose', 'onPopupClose');
    }
  }, {
    key: 'create',
    value: function create(props, context) {
      this.leaflet = require('leaflet');
      var createMarker = this.leaflet.marker;
      var tooltip = props.tooltip,
          position = props.position,
          options = props.options,
          divIcon = props.divIcon,
          defaultIcon = props.icon,
          onClick = props.onClick,
          onPopupOpen = props.onPopupOpen,
          onPopupClose = props.onPopupClose;


      var icon = (0, _utils.getIcon)(this.leaflet, divIcon, defaultIcon);
      var interactive = Boolean(onClick);
      var marker = createMarker((0, _data.reverse)(position), (0, _extends3.default)({}, options, { icon: icon, interactive: interactive }));

      if (tooltip) marker.bindTooltip(tooltip);
      if (onPopupOpen) marker.on('popupopen', onPopupOpen);
      if (onPopupClose) marker.on('popupclose', onPopupClose);
      if (onClick) marker.on('click', onClick);

      context.map.addLayer(marker);
      this.setMarker(marker);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.context.map.removeLayer(this.marker);
      this.marker.off();
      this.setMarker(null);
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.isReady) return this.props.children;
      return null;
    }
  }]);
  return Marker;
}(_map_component2.default);

Marker.childContextTypes = {
  marker: _propTypes2.default.object
};

Marker.defaultProps = {
  children: null
};

Marker.propTypes = {
  children: _propTypes2.default.node,
  position: _propTypes2.default.arrayOf(_propTypes2.default.number),
  options: _propTypes2.default.object,
  divIcon: _propTypes2.default.object,
  icon: _propTypes2.default.object,
  tooltip: _propTypes2.default.string,

  onClick: _propTypes2.default.func,
  onPopupOpen: _propTypes2.default.func,
  onPopupClose: _propTypes2.default.func
};

exports.default = Marker;