'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _map_component = require('nebenan-base-class/lib/map_component');

var _map_component2 = _interopRequireDefault(_map_component);

var _data = require('nebenan-helpers/lib/utils/data');

var _utils = require('./utils');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Polygon = function (_MapComponent) {
  (0, _inherits3.default)(Polygon, _MapComponent);

  function Polygon() {
    (0, _classCallCheck3.default)(this, Polygon);
    return (0, _possibleConstructorReturn3.default)(this, (Polygon.__proto__ || Object.getPrototypeOf(Polygon)).apply(this, arguments));
  }

  (0, _createClass3.default)(Polygon, [{
    key: 'update',
    value: function update(nextProps, nextContext) {
      this.destroy();
      this.create(nextProps, nextContext);
    }
  }, {
    key: 'create',
    value: function create(props, context) {
      var _require = require('leaflet'),
          createPolygon = _require.polygon;

      var area = props.area,
          onClick = props.onClick;

      var options = (0, _utils.getOptions)(props);
      var polygon = createPolygon(area.map(_data.reverse), options);

      if (onClick) polygon.on('click', onClick);

      context.map.addLayer(polygon);
      this.polygon = polygon;
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.polygon.off();
      this.context.map.removeLayer(this.polygon);
      this.polygon = null;
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);
  return Polygon;
}(_map_component2.default); /* eslint react/no-unused-prop-types: "off" */


Polygon.defaultProps = {
  type: _constants.POLYGON_DEFAULT
};

Polygon.propTypes = {
  type: _propTypes2.default.oneOf([_constants.POLYGON_ACTIVE, _constants.POLYGON_HIGHLIGHTED, _constants.POLYGON_SOLID, _constants.POLYGON_THIN, _constants.POLYGON_DEFAULT]).isRequired,

  area: _propTypes2.default.arrayOf(_propTypes2.default.arrayOf(_propTypes2.default.number)).isRequired,

  options: _propTypes2.default.object,

  onClick: _propTypes2.default.func
};

exports.default = Polygon;