'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getOptions = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _STYLES;

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var COLOR_ACTION = '#afca0b';
var COLOR_DARK70 = '#757575';

var WEIGHT_S = 1;
var WEIGHT_L = 4;

var OPACITY_N = 0;
var OPACITY_S = .2;
var OPACITY_M = .5;

var borderStyles = { weight: WEIGHT_L, dashArray: null, color: COLOR_DARK70 };

var STYLES = (_STYLES = {}, (0, _defineProperty3.default)(_STYLES, _constants.POLYGON_ACTIVE, (0, _extends3.default)({}, borderStyles, {
  fillColor: COLOR_ACTION,
  fillOpacity: OPACITY_S
})), (0, _defineProperty3.default)(_STYLES, _constants.POLYGON_HIGHLIGHTED, (0, _extends3.default)({}, borderStyles, {
  fillColor: COLOR_DARK70,
  fillOpacity: OPACITY_M
})), (0, _defineProperty3.default)(_STYLES, _constants.POLYGON_SOLID, (0, _extends3.default)({}, borderStyles, {
  fillColor: COLOR_DARK70,
  fillOpacity: OPACITY_S
})), (0, _defineProperty3.default)(_STYLES, _constants.POLYGON_THIN, (0, _extends3.default)({}, borderStyles, {
  fillColor: COLOR_DARK70,
  fillOpacity: OPACITY_S,
  weight: WEIGHT_S
})), (0, _defineProperty3.default)(_STYLES, _constants.POLYGON_DEFAULT, (0, _extends3.default)({}, borderStyles, {
  fillOpacity: OPACITY_N,
  dashArray: '5,10'
})), _STYLES);

var getOptions = exports.getOptions = function getOptions(_ref) {
  var type = _ref.type,
      onClick = _ref.onClick,
      override = _ref.options;

  var preset = STYLES[type];
  var interactive = Boolean(onClick);

  return (0, _extends3.default)({}, preset, { interactive: interactive }, override);
};