'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var Progress, React, classNames, getPercentage, omit;

  React = require('react');

  omit = require('lodash/omit');

  classNames = require('classnames');

  getPercentage = function getPercentage(input) {
    var percent;
    if (typeof input === 'number' && input < 1) {
      percent = String(input * 100);
    } else {
      percent = String(input);
    }
    if (percent.indexOf('%') === -1) {
      percent = percent + '%';
    }
    return percent;
  };

  Progress = function Progress(props) {
    var cleanProps, klass, percent, type;
    percent = getPercentage(props.state);
    type = props.type || 'primary';
    cleanProps = omit(props, 'className', 'state', 'size', 'type', 'children');
    klass = classNames('c-progress c-progress-' + type, props.className, {
      'c-progress-small': props.size === 'small'
    });
    return React.createElement(
      'div',
      (0, _extends3.default)({}, cleanProps, { className: klass }),
      React.createElement(
        'span',
        { className: 'c-progress-state', style: {
            width: percent
          } },
        React.createElement(
          'em',
          null,
          percent
        )
      ),
      props.children
    );
  };

  module.exports = Progress;
}).call(undefined);