'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

var _dom = require('nebenan-helpers/lib/utils/dom');

var _eventproxy = require('nebenan-helpers/lib/eventproxy');

var _eventproxy2 = _interopRequireDefault(_eventproxy);

var _interactive_component = require('nebenan-base-class/lib/interactive_component');

var _interactive_component2 = _interopRequireDefault(_interactive_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UPDATE_RATE = 20;
var MIN_SCROLLER_HEIGHT = 20;

var Scrollable = function (_InteractiveComponent) {
  (0, _inherits3.default)(Scrollable, _InteractiveComponent);

  function Scrollable(props) {
    (0, _classCallCheck3.default)(this, Scrollable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Scrollable.__proto__ || Object.getPrototypeOf(Scrollable)).call(this, props));

    _this.state = _this.getDefaultState();

    _this.bindToComponent('reset', 'resize', 'syncScrollPosition', 'handleResize', 'handleMouseEnter', 'handleMouseLeave', 'handleWheel', 'handleSwipeStart', 'handleSwipe', 'handleSwipeEnd', 'handleScroll', 'handleClick', 'handleLoad');

    _this.controlHeight = 0;
    _this.contentHeight = 0;
    _this.ratio = 1;
    _this.controlOffsetTop = 0;
    _this.scrolled = 0;
    return _this;
  }

  (0, _createClass3.default)(Scrollable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _get3.default)(Scrollable.prototype.__proto__ || Object.getPrototypeOf(Scrollable.prototype), 'componentDidMount', this).call(this);
      this.scroll = (0, _dom.scroll)(this.els.container);
      this.updateScrollPosition = (0, _throttle2.default)(this.updateScrollPosition, UPDATE_RATE);
      this.stopListeningToResize = (0, _eventproxy2.default)('resize', this.handleResize);
      this.resize();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.deactivateSwipe();
      this.stopListeningToResize();
      (0, _get3.default)(Scrollable.prototype.__proto__ || Object.getPrototypeOf(Scrollable.prototype), 'componentWillUnmount', this).call(this);
    }
  }, {
    key: 'getDefaultState',
    value: function getDefaultState() {
      return {
        isActive: false,
        scrollPosition: 0,
        containerWidth: 0,
        sliderHeight: MIN_SCROLLER_HEIGHT
      };
    }
  }, {
    key: 'reset',
    value: function reset(done) {
      var _this2 = this;

      var complete = function complete() {
        _this2.scroll.to(0);
        _this2.resize(done);
      };

      this.setState(this.getDefaultState(), complete);
    }
  }, {
    key: 'resize',
    value: function resize(done) {
      var componentSize = (0, _dom.size)(this.els.component);

      this.controlHeight = componentSize.height;
      this.contentHeight = (0, _dom.size)(this.els.content).height;
      this.ratio = Math.pow(this.controlHeight, 2) / this.contentHeight;
      this.controlOffsetTop = (0, _dom.documentOffset)(global, this.els.component).top;

      var containerWidth = componentSize.width;
      var sliderHeight = Math.max(MIN_SCROLLER_HEIGHT, this.ratio);

      this.setState({ containerWidth: containerWidth, sliderHeight: sliderHeight }, done);
    }
  }, {
    key: 'updateScrollPosition',
    value: function updateScrollPosition() {
      var percent = this.scrolled / this.contentHeight;
      var errorMargin = this.ratio - this.state.sliderHeight;
      var scrollPosition = percent * (this.controlHeight + errorMargin);

      this.setState({ scrollPosition: scrollPosition });
    }
  }, {
    key: 'syncScrollPosition',
    value: function syncScrollPosition() {
      this.scrolled = this.scroll.get();
      this.updateScrollPosition();
    }
  }, {
    key: 'setControlPosition',
    value: function setControlPosition(position) {
      var contentDiff = position * this.contentHeight / this.controlHeight;
      this.scroll.to(contentDiff);
    }
  }, {
    key: 'activate',
    value: function activate() {
      var _this3 = this;

      if (this.state.isActive) return;
      // Only activate when there is something to scroll
      var complete = function complete() {
        return _this3.setState({ isActive: _this3.contentHeight > _this3.controlHeight });
      };
      this.resize(complete);
    }
  }, {
    key: 'deactivate',
    value: function deactivate() {
      if (!this.state.isActive) return;
      this.setState({ isActive: false });
    }
  }, {
    key: 'activateSwipe',
    value: function activateSwipe() {
      if (this.isSwipeActive) return;
      document.addEventListener('mousemove', this.handleSwipe);
      document.addEventListener('touchmove', this.handleSwipe);
      document.addEventListener('mouseup', this.handleSwipeEnd);
      document.addEventListener('touchend', this.handleSwipeEnd);
      this.isSwipeActive = true;
    }
  }, {
    key: 'deactivateSwipe',
    value: function deactivateSwipe() {
      if (!this.isSwipeActive) return;
      document.removeEventListener('mousemove', this.handleSwipe);
      document.removeEventListener('touchmove', this.handleSwipe);
      document.removeEventListener('mouseup', this.handleSwipeEnd);
      document.removeEventListener('touchend', this.handleSwipeEnd);
      this.isSwipeActive = false;
    }
  }, {
    key: 'handleResize',
    value: function handleResize() {
      this.resize();
    }
  }, {
    key: 'handleMouseEnter',
    value: function handleMouseEnter(event) {
      this.activate();
      if (this.props.onMouseEnter) this.props.onMouseEnter(event);
    }
  }, {
    key: 'handleMouseLeave',
    value: function handleMouseLeave(event) {
      this.deactivate();
      if (this.props.onMouseLeave) this.props.onMouseLeave(event);
    }
  }, {
    key: 'handleWheel',
    value: function handleWheel(event) {
      var expectedPosition = this.scrolled + event.deltaY;
      var minPosition = 0;
      var maxPosition = this.contentHeight - this.controlHeight;

      var canScroll = void 0;
      var target = void 0;
      if (event.deltaY > 0) {
        canScroll = expectedPosition < maxPosition;
        target = maxPosition;
      } else {
        canScroll = expectedPosition > minPosition;
        target = minPosition;
      }

      if (!canScroll) {
        this.scroll.to(target);
        return (0, _dom.stopEvent)(event);
      }

      if (this.props.onWheel) return this.props.onWheel(event);
    }
  }, {
    key: 'handleSwipeStart',
    value: function handleSwipeStart(event) {
      this.activateSwipe();
      this.startY = (0, _dom.eventCoordinates)(event, 'pageY').pageY;
      this.startPosition = this.state.scrollPosition;
    }
  }, {
    key: 'handleSwipe',
    value: function handleSwipe(event) {
      var _eventCoordinates = (0, _dom.eventCoordinates)(event, 'pageY'),
          pageY = _eventCoordinates.pageY;

      var position = this.startPosition + pageY - this.startY;
      this.setControlPosition(position);
    }
  }, {
    key: 'handleSwipeEnd',
    value: function handleSwipeEnd() {
      this.deactivateSwipe();
      this.startY = null;
      this.startPosition = null;
      this.preventClick = true;
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll() {
      if (!this.state.isActive) this.activate();
      this.syncScrollPosition();
    }
  }, {
    key: 'handleClick',
    value: function handleClick(event) {
      if (this.preventClick) {
        this.preventClick = false;
        return;
      }

      var position = event.pageY - this.controlOffsetTop - this.state.sliderHeight / 2;
      this.setControlPosition(position);
    }
  }, {
    key: 'handleLoad',
    value: function handleLoad() {
      this.resize(this.syncScrollPosition);
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-scrollable', this.props.className);
      var cleanProps = (0, _omit2.default)(this.props, 'children');
      var controlClassName = (0, _classnames2.default)('c-scrollable-control', {
        'is-active': this.state.isActive
      });

      // Fixes issue with most browsers reducing width of the scrollable element children
      // as if to compensate for scrollbars, even when they are hidden
      var contentStyle = { width: this.state.containerWidth };

      var scrollerStyle = (0, _dom.getPrefixed)({ transform: 'translateY(' + this.state.scrollPosition + 'px)' });
      scrollerStyle.height = this.state.sliderHeight;

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className,
          ref: this.setEl('component'), onWheel: this.handleWheel,
          onMouseEnter: this.handleMouseEnter, onMouseLeave: this.handleMouseLeave
        }),
        _react2.default.createElement(
          'div',
          {
            className: 'c-scrollable-container', ref: this.setEl('container'),
            onScroll: this.handleScroll, onTouchMove: this.handleScroll
          },
          _react2.default.createElement(
            'div',
            {
              className: 'c-scrollable-content',
              ref: this.setEl('content'),
              onLoad: this.handleLoad,
              style: contentStyle
            },
            this.props.children
          )
        ),
        _react2.default.createElement(
          'span',
          { className: controlClassName, onClick: this.handleClick },
          _react2.default.createElement('i', {
            style: scrollerStyle,
            onTouchStart: this.handleSwipeStart,
            onMouseDown: this.handleSwipeStart
          })
        )
      );
    }
  }]);
  return Scrollable;
}(_interactive_component2.default);

Scrollable.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  onMouseEnter: _propTypes2.default.func,
  onMouseLeave: _propTypes2.default.func,
  onWheel: _propTypes2.default.func
};

exports.default = Scrollable;