'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get3 = require('babel-runtime/helpers/get');

var _get4 = _interopRequireDefault(_get3);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input_component = require('nebenan-base-class/lib/input_component');

var _input_component2 = _interopRequireDefault(_input_component);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _data = require('nebenan-helpers/lib/utils/data');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = function (_InputComponent) {
  (0, _inherits3.default)(Select, _InputComponent);

  function Select(props) {
    (0, _classCallCheck3.default)(this, Select);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.bindToComponent('handleChange');
    return _this;
  }

  (0, _createClass3.default)(Select, [{
    key: 'getDefaultState',
    value: function getDefaultState(props) {
      var state = (0, _get4.default)(Select.prototype.__proto__ || Object.getPrototypeOf(Select.prototype), 'getDefaultState', this).call(this, props);
      var hasValue = (0, _data.has)(state, 'value');
      if (hasValue) {
        state.index = (0, _utils.findIndex)(props, state.value);
      }

      if (state.index === -1 || !hasValue) {
        state.index = 0;
        state.value = (0, _utils.getOption)(props.options[state.index]).value;
      }

      return state;
    }
  }, {
    key: 'setValue',
    value: function setValue(newValue) {
      var _this2 = this;

      for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        rest[_key - 1] = arguments[_key];
      }

      if (!this.isComponentMounted) return;

      var updater = function updater(state, props) {
        return { index: (0, _utils.findIndex)(props, newValue) };
      };
      var complete = function complete() {
        var _get2;

        return (_get2 = (0, _get4.default)(Select.prototype.__proto__ || Object.getPrototypeOf(Select.prototype), 'setValue', _this2)).call.apply(_get2, [_this2, newValue].concat(rest));
      };
      this.setState(updater, complete);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var index = parseInt(event.target.value, 10);

      var _getOption = (0, _utils.getOption)(this.props.options[index]),
          value = _getOption.value;

      this.setValue(value, this.validate);
    }
  }, {
    key: 'renderOption',
    value: function renderOption(item, index) {
      var _getOption2 = (0, _utils.getOption)(item),
          key = _getOption2.key;

      return _react2.default.createElement(
        'option',
        { value: index, key: key },
        key
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-select', this.props.className);
      var cleanProps = (0, _omit2.default)(this.props, 'label', 'error', 'options', 'children', 'defaultValue', 'onUpdate');
      var hasError = this.isErrorActive();

      var inputClassName = (0, _classnames2.default)('ui-input', { 'ui-input-error': hasError });
      var options = this.props.options.map(this.renderOption);

      var error = void 0;
      if (hasError) error = _react2.default.createElement(
        'em',
        { className: 'ui-error' },
        this.getError()
      );

      return _react2.default.createElement(
        'label',
        { className: className },
        _react2.default.createElement(
          'strong',
          { className: 'ui-label' },
          this.props.label
        ),
        _react2.default.createElement(
          'div',
          { className: 'c-select-container' },
          _react2.default.createElement(
            'select',
            (0, _extends3.default)({}, cleanProps, { ref: this.setEl('input'), className: inputClassName,
              onChange: this.handleChange,
              onBlur: this.actionValidate(this.props.onBlur),
              value: this.state.index
            }),
            options
          ),
          _react2.default.createElement('i', { className: 'c-select-icon icon-arrow_down' }),
          this.props.children
        ),
        error
      );
    }
  }]);
  return Select;
}(_input_component2.default);

Select.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  options: _propTypes2.default.array.isRequired,

  label: _propTypes2.default.node,
  onBlur: _propTypes2.default.func,

  validate: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),

  required: _propTypes2.default.bool,
  pattern: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,

  error: _propTypes2.default.string,
  name: _propTypes2.default.string,

  onUpdate: _propTypes2.default.func,
  onError: _propTypes2.default.func
};

exports.default = Select;