'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var InputComponent,
      PropTypes,
      React,
      Slider,
      classNames,
      convertPercentToValue,
      convertValueToPercent,
      documentOffset,
      ensureValueBounds,
      eventCoordinates,
      eventproxy,
      getPrefixed,
      omit,
      size,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  PropTypes = require('prop-types');

  omit = require('lodash/omit');

  classNames = require('classnames');

  eventproxy = require('nebenan-helpers/lib/eventproxy').default;

  var _require = require('nebenan-helpers/lib/utils/dom');

  documentOffset = _require.documentOffset;
  size = _require.size;
  getPrefixed = _require.getPrefixed;
  eventCoordinates = _require.eventCoordinates;


  InputComponent = require('nebenan-base-class/lib/input_component');

  ensureValueBounds = function ensureValueBounds(value, min, max) {
    return Math.max(Math.min(value, max), min);
  };

  convertValueToPercent = function convertValueToPercent(value, min, max) {
    if (value) {
      return (value - min) / (max - min);
    } else {
      return 0;
    }
  };

  convertPercentToValue = function convertPercentToValue(percent, min, max, step) {
    var multiplier, value;
    multiplier = (max - min) / step;
    value = Math.round(percent * multiplier) * step + min;
    return ensureValueBounds(value, min, max);
  };

  Slider = function () {
    var Slider = function (_InputComponent) {
      (0, _inherits3.default)(Slider, _InputComponent);

      function Slider() {
        (0, _classCallCheck3.default)(this, Slider);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).apply(this, arguments));

        _this.handleGlobalClick = _this.handleGlobalClick.bind(_this);
        _this.handleResize = _this.handleResize.bind(_this);
        _this.handleClick = _this.handleClick.bind(_this);
        _this.handleSwipeStart = _this.handleSwipeStart.bind(_this);
        _this.handleSwipe = _this.handleSwipe.bind(_this);
        _this.handleSwipeEnd = _this.handleSwipeEnd.bind(_this);
        return _this;
      }

      (0, _createClass3.default)(Slider, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          (0, _get3.default)(Slider.prototype.__proto__ || Object.getPrototypeOf(Slider.prototype), 'componentDidMount', this).call(this);
          this.stopListeningToClicks = eventproxy('click', this.handleGlobalClick);
          this.stopListeningToResize = eventproxy('resize', this.handleResize);
          return this.handleResize();
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.deactivateSwipe();
          this.stopListeningToClicks();
          this.stopListeningToResize();
          return (0, _get3.default)(Slider.prototype.__proto__ || Object.getPrototypeOf(Slider.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'getDefaultState',
        value: function getDefaultState(props) {
          var state;
          state = (0, _get3.default)(Slider.prototype.__proto__ || Object.getPrototypeOf(Slider.prototype), 'getDefaultState', this).call(this, props);
          state.value = ensureValueBounds(state.value || 0, props.min, props.max);
          state.percent = convertValueToPercent(state.value, props.min, props.max);
          return state;
        }
      }, {
        key: 'getTrackOffset',
        value: function getTrackOffset() {
          return documentOffset(global, this.refs.track).left;
        }
      }, {
        key: 'handleGlobalClick',
        value: function handleGlobalClick(event) {
          boundMethodCheck(this, Slider);
          if (!this.isComponentMounted) {
            return;
          }
          if (!this.isPristine() && !this.refs.container.contains(event.target)) {
            return this.validate();
          }
        }
      }, {
        key: 'handleResize',
        value: function handleResize() {
          var trackWidth;
          boundMethodCheck(this, Slider);
          if (!this.isComponentMounted) {
            return;
          }
          trackWidth = size(this.refs.track).width;
          return this.setState({ trackWidth: trackWidth });
        }
      }, {
        key: 'activateSwipe',
        value: function activateSwipe() {
          if (this.isActive) {
            return;
          }
          document.addEventListener('mousemove', this.handleSwipe);
          document.addEventListener('touchmove', this.handleSwipe);
          document.addEventListener('mouseup', this.handleSwipeEnd);
          document.addEventListener('touchend', this.handleSwipeEnd);
          this.setError(null);
          return this.isActive = true;
        }
      }, {
        key: 'deactivateSwipe',
        value: function deactivateSwipe() {
          if (!this.isActive) {
            return;
          }
          document.removeEventListener('mousemove', this.handleSwipe);
          document.removeEventListener('touchmove', this.handleSwipe);
          document.removeEventListener('mouseup', this.handleSwipeEnd);
          document.removeEventListener('touchend', this.handleSwipeEnd);
          return this.isActive = false;
        }
      }, {
        key: 'handleClick',
        value: function handleClick(event) {
          boundMethodCheck(this, Slider);
          return this.setPosition(event.pageX - this.getTrackOffset(), this.validate);
        }
      }, {
        key: 'handleSwipeStart',
        value: function handleSwipeStart() {
          boundMethodCheck(this, Slider);
          this.activateSwipe();
          return this.trackOffset = this.getTrackOffset();
        }
      }, {
        key: 'handleSwipe',
        value: function handleSwipe(event) {
          var pageX;
          boundMethodCheck(this, Slider);
          event.preventDefault();

          var _eventCoordinates = eventCoordinates(event, 'pageX');

          pageX = _eventCoordinates.pageX;

          return this.setPosition(pageX - this.trackOffset);
        }
      }, {
        key: 'handleSwipeEnd',
        value: function handleSwipeEnd() {
          boundMethodCheck(this, Slider);
          this.deactivateSwipe();
          return this.trackOffset = null;
        }
      }, {
        key: 'setPosition',
        value: function setPosition(position, done) {
          var percent, value;
          percent = Math.max(Math.min(position / this.state.trackWidth, 1), 0);
          value = convertPercentToValue(percent, this.props.min, this.props.max, this.props.step);
          if (value !== this.state.value) {
            return this.setValue(value, done);
          } else {
            return typeof done === "function" ? done() : void 0;
          }
        }
      }, {
        key: 'setValue',
        value: function setValue(value, done) {
          this.setState(function (state, props) {
            return {
              percent: convertValueToPercent(value, props.min, props.max)
            };
          });
          return (0, _get3.default)(Slider.prototype.__proto__ || Object.getPrototypeOf(Slider.prototype), 'setValue', this).call(this, value, done);
        }
      }, {
        key: 'render',
        value: function render() {
          var className, cleanProps, error, label, style;
          className = classNames('c-slider', this.props.className, {
            'is-error': this.isErrorActive()
          });
          cleanProps = omit(this.props, 'label', 'error', 'validate', 'required', 'children', 'min', 'max', 'step', 'getLabel', 'onUpdate');
          if (this.props.getLabel) {
            label = this.props.getLabel(this.state.value);
          } else {
            label = this.state.value;
          }
          style = getPrefixed({
            transform: 'translateX(' + this.state.percent * this.state.trackWidth + 'px)'
          });
          if (this.isErrorActive()) {
            error = React.createElement(
              'em',
              { className: 'ui-error' },
              this.getError()
            );
          }
          return React.createElement(
            'article',
            (0, _extends3.default)({}, cleanProps, { className: className, ref: 'container' }),
            React.createElement(
              'strong',
              { className: 'ui-label' },
              this.props.label
            ),
            React.createElement(
              'div',
              { className: 'c-slider-track', ref: 'track', onClick: this.handleClick },
              React.createElement('span', { className: 'c-slider-line' }),
              React.createElement(
                'span',
                { ref: 'handle', className: 'c-slider-handle', style: style, onTouchStart: this.handleSwipeStart, onMouseDown: this.handleSwipeStart },
                React.createElement(
                  'em',
                  { className: 'c-slider-label' },
                  label
                )
              )
            ),
            error
          );
        }
      }]);
      return Slider;
    }(InputComponent);

    ;

    Slider.propTypes = {
      step: PropTypes.number,
      min: PropTypes.number,
      max: PropTypes.number
    };

    Slider.defaultProps = {
      step: 1,
      min: 0,
      max: 10
    };

    return Slider;
  }();

  module.exports = Slider;
}).call(undefined);