'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _interactive_component = require('nebenan-base-class/lib/interactive_component');

var _interactive_component2 = _interopRequireDefault(_interactive_component);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _clamp = require('lodash/clamp');

var _clamp2 = _interopRequireDefault(_clamp);

var _eventproxy = require('nebenan-helpers/lib/eventproxy');

var _eventproxy2 = _interopRequireDefault(_eventproxy);

var _heartbeat = require('nebenan-helpers/lib/heartbeat');

var _heartbeat2 = _interopRequireDefault(_heartbeat);

var _dom = require('nebenan-helpers/lib/utils/dom');

var _utils = require('./utils');

var _draggable = require('../draggable');

var _draggable2 = _interopRequireDefault(_draggable);

var _dots = require('../dots');

var _dots2 = _interopRequireDefault(_dots);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Slideshow = function (_InteractiveComponent) {
  (0, _inherits3.default)(Slideshow, _InteractiveComponent);

  function Slideshow(props) {
    (0, _classCallCheck3.default)(this, Slideshow);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Slideshow.__proto__ || Object.getPrototypeOf(Slideshow)).call(this, props));

    _this.state = _this.getDefaultState();

    _this.bindToComponent('snapToGrid', 'setSection', 'nextSection', 'prevSection', 'handleDragStart', 'handleDrag', 'handleDragStop', 'handleResize', 'renderItem');
    return _this;
  }

  (0, _createClass3.default)(Slideshow, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _get3.default)(Slideshow.prototype.__proto__ || Object.getPrototypeOf(Slideshow.prototype), 'componentDidMount', this).call(this);
      this.startAutoRotation();
      this.stopListeningToResize = (0, _eventproxy2.default)('resize', this.handleResize);
      this.calculateMeasurements();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.stopListeningToResize();
      this.stopAutoRotation();
      (0, _get3.default)(Slideshow.prototype.__proto__ || Object.getPrototypeOf(Slideshow.prototype), 'componentWillUnmount', this).call(this);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var isLengthChanged = prevProps.items.length !== this.props.items.length;
      var itemWidthChanged = (0, _utils.isItemWidthChanged)(prevProps, this.props);

      if (isLengthChanged || itemWidthChanged) this.handleResize();
    }
  }, {
    key: 'getDefaultState',
    value: function getDefaultState() {
      return {
        position: 0,
        section: 0,
        isAnimated: false,

        sceneWidth: 0,
        itemWidth: 0,
        listWidth: 0
      };
    }
  }, {
    key: 'startAutoRotation',
    value: function startAutoRotation() {
      if (this.props.rotationInterval) {
        this.stopAutoRotation();
        this.removeRotationListener = (0, _heartbeat2.default)(this.props.rotationInterval, this.nextSection);
      }
    }
  }, {
    key: 'stopAutoRotation',
    value: function stopAutoRotation() {
      if (this.removeRotationListener) {
        this.removeRotationListener();
        this.removeRotationListener = null;
      }
    }
  }, {
    key: 'getValidPosition',
    value: function getValidPosition(position) {
      return (0, _clamp2.default)(position, this.minPosition, 0);
    }
  }, {
    key: 'setSection',
    value: function setSection(index) {
      var position = index * this.state.sceneWidth * -1;
      this.setPosition(this.getValidPosition(position));

      this.startAutoRotation();
    }
  }, {
    key: 'setPosition',
    value: function setPosition(position) {
      var _this2 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _utils.getPositionOptions)();

      var updater = function updater(state) {
        return {
          position: position,
          section: (0, _utils.getActiveSection)(position, state.sceneWidth),
          isAnimated: options.animated
        };
      };

      var done = void 0;
      if (this.props.onChange) done = function done() {
        _this2.props.onChange(_this2.state.section);
      };

      this.setState(updater, done);
    }
  }, {
    key: 'snapToGrid',
    value: function snapToGrid() {
      var position = (0, _utils.getGridPosition)(this.state.position, this.state.sceneWidth, this.direction);
      this.setPosition(this.getValidPosition(position));
    }
  }, {
    key: 'calculateMeasurements',
    value: function calculateMeasurements(done) {
      var _this3 = this;

      var updater = function updater(state, props) {
        var sceneWidth = (0, _dom.size)(_this3.els.element).width;
        var itemWidth = (0, _utils.getItemWidth)(global, sceneWidth, props);
        var listWidth = itemWidth * props.items.length;

        _this3.minPosition = Math.min(sceneWidth - listWidth, 0);
        return { sceneWidth: sceneWidth, itemWidth: itemWidth, listWidth: listWidth };
      };

      this.setState(updater, done);
    }
  }, {
    key: 'nextSection',
    value: function nextSection() {
      var index = this.state.section + 1;
      if (index >= this.sectionsCount) index = 0;
      this.setSection(index);
    }
  }, {
    key: 'prevSection',
    value: function prevSection() {
      var index = this.state.section - 1;
      if (index < 0) index = this.sectionsCount - 1;
      this.setSection(index);
    }
  }, {
    key: 'handleResize',
    value: function handleResize() {
      if (!this.isComponentMounted) return;
      this.calculateMeasurements(this.snapToGrid);
    }
  }, {
    key: 'handleDragStart',
    value: function handleDragStart(event) {
      this.startPosition = this.state.position;
      this.startX = (0, _dom.eventCoordinates)(event, 'pageX').pageX;
      this.stopAutoRotation();
    }
  }, {
    key: 'handleDrag',
    value: function handleDrag(event) {
      var diff = (0, _dom.eventCoordinates)(event, 'pageX').pageX - this.startX;
      var minPosition = this.minPosition - _utils.BOUNDARIES_EXCESS;
      var position = (0, _clamp2.default)(this.startPosition + diff, minPosition, _utils.BOUNDARIES_EXCESS);

      this.direction = this.startPosition - position;
      this.setPosition(position, { animated: false });

      if (Math.abs(diff) >= _utils.DISABLE_SCROLL_DISTANCE) event.preventDefault();
    }
  }, {
    key: 'handleDragStop',
    value: function handleDragStop() {
      var diff = Math.abs(this.startPosition - this.state.position);

      if (diff >= _utils.SWIPE_TRIGGER_DISTANCE) {
        this.snapToGrid();
      } else {
        this.setPosition(this.startPosition);
      }

      this.startAutoRotation();
    }
  }, {
    key: 'renderDots',
    value: function renderDots() {
      if (this.props.items.length <= 1) return null;

      return _react2.default.createElement(_dots2.default, {
        count: this.sectionsCount,
        active: this.state.section,
        onItemClick: this.setSection
      });
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item) {
      return _react2.default.createElement(
        'li',
        { style: { width: this.state.itemWidth } },
        item
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-slideshow', this.props.className, { 'is-animated': this.state.isAnimated });
      var cleanProps = (0, _omit2.default)(this.props, 'items', 'visibleMobile', 'visibleTablet', 'visibleDesktop', 'rotationInterval');
      var items = this.props.items;


      var content = _react.Children.map(items, this.renderItem);
      var draggableStyle = (0, _dom.getPrefixed)({ transform: 'translateX(' + this.state.position + 'px)' });

      this.sectionsCount = (0, _utils.getSectionsCount)(this.state.sceneWidth, this.state.listWidth);

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className, ref: this.setEl('element') }),
        _react2.default.createElement(
          _draggable2.default,
          {
            ref: this.setEl('draggable'),
            style: draggableStyle,
            className: 'c-slideshow-draggable',

            onDragStart: this.handleDragStart,
            onDrag: this.handleDrag,
            onDragStop: this.handleDragStop
          },
          _react2.default.createElement(
            'ul',
            { className: 'c-slideshow-list' },
            content
          )
        ),
        this.renderDots()
      );
    }
  }]);
  return Slideshow;
}(_interactive_component2.default);

Slideshow.defaultProps = {
  visibleMobile: 1,
  visibleTablet: 2,
  visibleDesktop: 3
};

Slideshow.propTypes = {
  className: _propTypes2.default.string,

  items: _propTypes2.default.array.isRequired,

  visibleMobile: _propTypes2.default.number.isRequired,
  visibleTablet: _propTypes2.default.number.isRequired,
  visibleDesktop: _propTypes2.default.number.isRequired,

  rotationInterval: _propTypes2.default.number
};

exports.default = Slideshow;