'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPositionOptions = exports.isItemWidthChanged = exports.getActiveSection = exports.getSectionsCount = exports.getGridPosition = exports.getItemWidth = exports.SWIPE_TRIGGER_DISTANCE = exports.DISABLE_SCROLL_DISTANCE = exports.BOUNDARIES_EXCESS = undefined;

var _dom = require('nebenan-helpers/lib/utils/dom');

var BOUNDARIES_EXCESS = exports.BOUNDARIES_EXCESS = 40;
var DISABLE_SCROLL_DISTANCE = exports.DISABLE_SCROLL_DISTANCE = 10;
var SWIPE_TRIGGER_DISTANCE = exports.SWIPE_TRIGGER_DISTANCE = 20;

var getItemWidth = exports.getItemWidth = function getItemWidth(win, sceneWidth, props) {
  var mediaType = 'Mobile';
  if ((0, _dom.getMedia)(win, _dom.media.mediaM)) mediaType = 'Tablet';
  if ((0, _dom.getMedia)(win, _dom.media.mediaL)) mediaType = 'Desktop';

  return sceneWidth / props['visible' + mediaType];
};

var getGridPosition = exports.getGridPosition = function getGridPosition(position, sceneWidth, direction) {
  var gridPosition = position - position % sceneWidth;
  if (direction > 0) gridPosition -= sceneWidth;
  return gridPosition;
};

var getSectionsCount = exports.getSectionsCount = function getSectionsCount(sceneWidth, listWidth) {
  return Math.ceil(listWidth / sceneWidth) || 1;
};

var getActiveSection = exports.getActiveSection = function getActiveSection(position, sceneWidth) {
  return Math.round(Math.abs(position / sceneWidth));
};

var isItemWidthChanged = exports.isItemWidthChanged = function isItemWidthChanged(prevProps, props) {
  if (prevProps.visibleMobile !== props.visibleMobile) return true;
  if (prevProps.visibleTablet !== props.visibleTablet) return true;
  if (prevProps.visibleDesktop !== props.visibleDesktop) return true;

  return false;
};

var getPositionOptions = exports.getPositionOptions = function getPositionOptions() {
  return {
    animated: true
  };
};