'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultGetItem = function defaultGetItem(index, items) {
  return items[index].text;
};

var TabBar = function (_PureComponent) {
  (0, _inherits3.default)(TabBar, _PureComponent);

  function TabBar(props) {
    (0, _classCallCheck3.default)(this, TabBar);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TabBar.__proto__ || Object.getPrototypeOf(TabBar)).call(this, props));

    _this.renderItem = _this.renderItem.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(TabBar, [{
    key: 'handleClick',
    value: function handleClick(key) {
      var item = this.props.items[key];
      if (item.href) this.context.router.push(item.href);
      if (item.callback) item.callback(key);
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, key) {
      var _props = this.props,
          activeIndex = _props.activeIndex,
          getItem = _props.getItem,
          items = _props.items;

      var renderer = getItem || defaultGetItem;

      var className = (0, _classnames2.default)('c-tab_bar-item', {
        'is-active': key === activeIndex
      });
      var onClick = this.handleClick.bind(this, key);
      var props = { key: key, className: className, onClick: onClick };

      return _react2.default.createElement(
        'li',
        props,
        renderer(key, items)
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-tab_bar', this.props.className);
      var cleanProps = (0, _omit2.default)(this.props, 'children', 'action', 'items', 'getItem', 'activeIndex');
      var _props2 = this.props,
          items = _props2.items,
          action = _props2.action,
          children = _props2.children;


      var list = void 0;
      if (items) list = _react2.default.createElement(
        'ul',
        { className: 'c-tab_bar-list' },
        items.map(this.renderItem)
      );

      var actionNode = void 0;
      if (action) actionNode = _react2.default.createElement(
        'span',
        { className: 'c-tab_bar-action' },
        action
      );

      var content = void 0;
      if (children) content = _react2.default.createElement(
        'span',
        { className: 'c-tab_bar-content' },
        children
      );

      return _react2.default.createElement(
        'article',
        (0, _extends3.default)({}, cleanProps, { className: className }),
        actionNode,
        _react2.default.createElement(
          'div',
          { className: 'c-tab_bar-container' },
          list,
          content
        )
      );
    }
  }]);
  return TabBar;
}(_react.PureComponent);

TabBar.contextTypes = {
  router: _propTypes2.default.object
};

exports.default = TabBar;