'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var CHECKBOX_CHANGE_RATE,
      Emoji,
      InputComponent,
      PropTypes,
      React,
      TAG_LIMIT,
      TagCloud,
      classNames,
      eventproxy,
      omit,
      throttle,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  },
      indexOf = [].indexOf;

  React = require('react');

  PropTypes = require('prop-types');

  omit = require('lodash/omit');

  throttle = require('lodash/throttle');

  classNames = require('classnames');

  eventproxy = require('nebenan-helpers/lib/eventproxy').default;

  InputComponent = require('nebenan-base-class/lib/input_component');

  Emoji = require('../emoji').default;

  TAG_LIMIT = 15;

  CHECKBOX_CHANGE_RATE = 300;

  TagCloud = function () {
    var TagCloud = function (_InputComponent) {
      (0, _inherits3.default)(TagCloud, _InputComponent);

      function TagCloud(props) {
        (0, _classCallCheck3.default)(this, TagCloud);

        if (props.multiple && props.radio) {
          throw new Error('TagCloud can be either multiple, or radio, not both.');
        }

        var _this = (0, _possibleConstructorReturn3.default)(this, (TagCloud.__proto__ || Object.getPrototypeOf(TagCloud)).call(this, props));

        _this.handleGlobalClick = _this.handleGlobalClick.bind(_this);
        _this.renderTag = _this.renderTag.bind(_this);
        return _this;
      }

      (0, _createClass3.default)(TagCloud, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (!this.props.readOnly) {
            this.activate();
          }
          return (0, _get3.default)(TagCloud.prototype.__proto__ || Object.getPrototypeOf(TagCloud.prototype), 'componentDidMount', this).call(this);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.deactivate();
          return (0, _get3.default)(TagCloud.prototype.__proto__ || Object.getPrototypeOf(TagCloud.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          if (nextProps.readOnly) {
            return this.deactivate();
          } else {
            return this.activate();
          }
        }
      }, {
        key: 'getDefaultState',
        value: function getDefaultState(props) {
          var state;
          state = (0, _get3.default)(TagCloud.prototype.__proto__ || Object.getPrototypeOf(TagCloud.prototype), 'getDefaultState', this).call(this, props);
          if (state.value == null) {
            state.value = props.multiple ? [] : null;
          }
          return state;
        }
      }, {
        key: 'activate',
        value: function activate() {
          if (this.isActive) {
            return;
          }
          this.stopListeningToClicks = eventproxy('click', this.handleGlobalClick);
          return this.isActive = true;
        }
      }, {
        key: 'deactivate',
        value: function deactivate() {
          if (!this.isActive) {
            return;
          }
          this.stopListeningToClicks();
          return this.isActive = false;
        }
      }, {
        key: 'handleGlobalClick',
        value: function handleGlobalClick(event) {
          boundMethodCheck(this, TagCloud);
          if (!this.isComponentMounted) {
            return;
          }
          if (!this.isPristine() && !this.refs.container.contains(event.target)) {
            return this.validate();
          }
        }
      }, {
        key: 'getOption',
        value: function getOption(option) {
          var key, value;
          if ((typeof option === 'undefined' ? 'undefined' : (0, _typeof3.default)(option)) === 'object') {
            key = option.key;
            value = option.value;
          } else {
            key = value = option;
          }
          return { key: key, value: value };
        }
      }, {
        key: 'handleClick',
        value: function handleClick(item, event) {
          var currentValue, index, newValue, value;

          var _getOption = this.getOption(item);

          value = _getOption.value;

          currentValue = this.getValue();
          if (this.props.multiple) {
            newValue = currentValue.slice();
            index = newValue.indexOf(value);
            if (index >= 0) {
              newValue.splice(index, 1);
            } else {
              newValue.push(value);
            }
          } else {
            if (currentValue === value && !this.props.radio) {
              newValue = null;
            } else {
              newValue = value;
            }
          }
          if (newValue !== currentValue) {
            this.setValue(newValue);
          }
          return this.actionClearError(this.props.onClick)(event);
        }
      }, {
        key: 'renderTag',
        value: function renderTag(item, index) {
          var className, currentValue, isActive, key, text, value;
          boundMethodCheck(this, TagCloud);

          var _getOption2 = this.getOption(item);

          key = _getOption2.key;
          value = _getOption2.value;

          currentValue = this.getValue();
          if (currentValue != null) {
            if (this.props.multiple) {
              isActive = indexOf.call(currentValue, value) >= 0;
            } else {
              isActive = value === currentValue;
            }
          }
          className = classNames('c-tag_cloud-item ui-tag', {
            'ui-tag-secondary': !isActive,
            'ui-tag-tertiary is-active': isActive
          });
          text = React.createElement(Emoji, { text: key, limit: TAG_LIMIT });
          if (this.props.readOnly) {
            return React.createElement(
              'li',
              { key: value, className: className },
              text
            );
          } else {
            return React.createElement(
              'li',
              { key: value, className: className, onClick: this.handleClick.bind(this, item) },
              text
            );
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var className, cleanProps, error, label;
          className = classNames('c-tag_cloud', this.props.className, {
            'is-locked': this.props.readOnly,
            'is-radio': this.props.radio
          });
          cleanProps = omit(this.props, 'label', 'error', 'items', 'validate', 'required', 'multiple', 'readOnly', 'onClick', 'onUpdate', 'radio', 'children');
          if (this.isErrorActive()) {
            error = React.createElement(
              'em',
              { className: 'ui-error' },
              this.getError()
            );
          }
          if (this.props.label) {
            label = React.createElement(
              'strong',
              { className: 'ui-label c-tag_cloud-label' },
              this.props.label
            );
          }
          return React.createElement(
            'article',
            (0, _extends3.default)({}, cleanProps, { className: className, ref: 'container' }),
            label,
            React.createElement(
              'ul',
              { className: 'c-tag_cloud-list' },
              this.props.items.map(this.renderTag)
            ),
            this.props.children,
            error
          );
        }
      }]);
      return TagCloud;
    }(InputComponent);

    ;

    TagCloud.propTypes = {
      items: PropTypes.array.isRequired
    };

    return TagCloud;
  }();

  TagCloud.prototype.setValue = throttle(TagCloud.prototype.setValue, CHECKBOX_CHANGE_RATE);

  module.exports = TagCloud;
}).call(undefined);