'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _data = require('nebenan-helpers/lib/utils/data');

var _input_proxy_component = require('nebenan-base-class/lib/input_proxy_component');

var _input_proxy_component2 = _interopRequireDefault(_input_proxy_component);

var _tag_cloud = require('../tag_cloud');

var _tag_cloud2 = _interopRequireDefault(_tag_cloud);

var _tag_input = require('../tag_input');

var _tag_input2 = _interopRequireDefault(_tag_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TagsPicker = function (_InputProxyComponent) {
  (0, _inherits3.default)(TagsPicker, _InputProxyComponent);

  function TagsPicker(props) {
    (0, _classCallCheck3.default)(this, TagsPicker);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TagsPicker.__proto__ || Object.getPrototypeOf(TagsPicker)).call(this, props));

    _this.bindToComponent('handleSelect');
    return _this;
  }

  (0, _createClass3.default)(TagsPicker, [{
    key: 'handleSelect',
    value: function handleSelect(tag) {
      if (this.itemsHash[tag]) return;

      this.props.onSelect(tag);
      this.els.tagInput.reset();
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('c-tags_picker', this.props.className);
      var cleanProps = (0, _omit2.default)(this.props, 'children', 'placeholder', 'options', 'items', 'onSelect');

      var _props = this.props,
          options = _props.options,
          items = _props.items,
          placeholder = _props.placeholder,
          children = _props.children;

      this.itemsHash = (0, _data.arrayToHash)(items);

      return _react2.default.createElement(
        _tag_cloud2.default,
        (0, _extends3.default)({}, cleanProps, { ref: this.setEl('input'), items: items, className: className }),
        _react2.default.createElement(_tag_input2.default, {
          ref: this.setEl('tagInput'),
          placeholder: placeholder,
          options: options,
          onSelect: this.handleSelect
        }),
        children
      );
    }
  }]);
  return TagsPicker;
}(_input_proxy_component2.default);

TagsPicker.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,

  placeholder: _propTypes2.default.string,
  options: _propTypes2.default.array,
  items: _propTypes2.default.array,

  onSelect: _propTypes2.default.func.isRequired
};

exports.default = TagsPicker;