'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MIN_UPDATE_RATE = 1000 * 60;

var TimeAgo = function (_PureComponent) {
  (0, _inherits3.default)(TimeAgo, _PureComponent);

  function TimeAgo(props) {
    (0, _classCallCheck3.default)(this, TimeAgo);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TimeAgo.__proto__ || Object.getPrototypeOf(TimeAgo)).call(this, props));

    _this.updateTime = _this.updateTime.bind(_this);

    _this.state = {
      date: null
    };
    return _this;
  }

  (0, _createClass3.default)(TimeAgo, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateTime();

      if (this.props.updateInterval) {
        var rate = Math.max(MIN_UPDATE_RATE, this.props.updateInterval);
        var heartbeat = require('nebenan-helpers/lib/heartbeat').default;
        this.cancelHeartbeat = heartbeat(rate, this.updateTime);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.cancelHeartbeat) this.cancelHeartbeat();
    }
  }, {
    key: 'updateTime',
    value: function updateTime() {
      this.setState(function (state, props) {
        return { date: (0, _utils.getDateDiff)(Date.now(), props.date) };
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var cleanProps = (0, _omit2.default)(this.props, 'children', 'date', 'updateInterval');
      var _props = this.props,
          children = _props.children,
          date = _props.date;

      return _react2.default.createElement(
        'time',
        (0, _extends3.default)({}, cleanProps, { dateTime: date }),
        this.state.date,
        ' ',
        children
      );
    }
  }]);
  return TimeAgo;
}(_react.PureComponent);

exports.default = TimeAgo;