'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDateDiff = undefined;

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getDateDiff = exports.getDateDiff = function getDateDiff(now, date) {
  var nowMoment = (0, _moment2.default)(now);
  var dateMoment = (0, _moment2.default)(date);

  if (Math.abs(dateMoment.diff(nowMoment, 'days')) > 7) return dateMoment.format('L');

  // To fix the case where user's time is behind the server time
  // we create a time that was a 'second ago', diff it and display that
  // in case we have a "date from the future"
  nowMoment.subtract(1, 'seconds');
  if (dateMoment.diff(nowMoment) < 0) return dateMoment.fromNow();

  return nowMoment.fromNow();
};